function Configuration() {
	var _this = this;
	_this.language = {
		defaultLang:"eng",
		lang: "eng",
		dir: "ltr"
	}
	_this.tracking = {
		/**
		 *  0: STANDALONE/local storage -- current
		 *  1: SCORM1.2 
		 *  2: SCORM2004 v3 
		 */
		complianceType: 0
	}
    _this.breakPoint={
        mobile: 834,
		small:667
    },
	_this.filePath = {
		dataPath: "content/nav/",
		langFolderPath: "content/lang/"
	}
	_this.system={
		toBeChecked:false,
		supported:[
			{
				id:"OS",
				name: "Operating System",
				data:[
					{
						id:"ios",
						min:"6",
						max:"12"
					},{
						id: "windows",
						min: "6.10",
						max: "10.00"
					}, {
						id: "windows rt",
						min: "8.00",
						max: "10.00"
					}, {
						id: "mac",
						min: "10.08",
						max: "10.14"
					}, {
						id: "android",
						min: "4",
						max: "10"
					}
				]
			},{
                id: "browser",
                name: "Web Browser",
                data: [
                    {
                        "id": "ie",
                        "min": "11",
                        "max": "11"
                    }, {
                        "id": "firefox",
                        "min": "52",
                        "max": "60"
                    }, {
                        "id": "edge",
                        "min": "12",
                        "max": "15"
                    }, {
                        "id": "chrome",
                        "min": "47",
                        "max": "60"
                    }, {
                        "id": "safari",
                        "min": "5",
                        "max": "12"
                    }, {
                        "id": "iron",
                        "min": "1",
                        "max": "12"
                    }
                ]
            }, {
                "id": "device",
                "name": "Device",
                "data": [
                    {
                        "id": "tablet"
                    }, {
                        "id": "mobile"
                    }, {
                        "id": "desktop"
                    }
                ]
            }, {
                "id": "model",
                "name": "Device Model",
                "data": [
                    {
                        "id": "ipad"
                    }, {
                        "id": "iphone"
                    }, {
                        "id": "android"
                    }, {
                        "id": "windows phone"
                    }, {
                        "id": "windows tablet"
                    }
                ]
            }
		]
	}
}