function Common() {
	var _this = this;
	
	var timeInterval = null;
	
	//--custom edit for client
	var lmsInterval = null;
	var lmsIntervalTime = 180000 // 3 minutes
	//--
	
	_this.changeLanguage = function (_lang, _dir) {
		if (APP.configObj.language.lang != _lang) {
			APP.userLanguageChanged = true;
			APP.configObj.language.lang = _lang;
			APP.configObj.language.dir = _dir;
		}
		if (APP.userLanguageChanged) {
			APP.globalXmlsObj.loadGlobalXML();
		} else {
			APP.navigationObj.loadNextPage();
		}
	}
	
	_this.preloadImages = function() {
	  for (var i = 0; i < arguments.length; i++) {
		$("<img />").attr("src", arguments[i]);
	  }
	}
	_this.showExitPop=function(){
		if(APP.globalMessageOpen){return false;}
		var $alertObj=$('.exit-pop');
		$alertObj.find('.modal-alert').removeClass('animated bounceIn bounceOut');
		if($alertObj.find('.modal-alert').length){
			$alertObj.show();
			$alertObj.find('.modal-alert').addClass('bounceIn animated');
			APP.globalMessageOpen=true;
			return false;
		}
		
		$alertObj.html(getAlertWinHtml());
		
		var textObj=APP.globalXmlsObj.screenDataXML.exitPopText[0];
		
		$alertObj.find('.modal-title').html(textObj.title[0].Text);
		var txtObj = textObj.text;
		var txtLen = txtObj.length;
		var txt=txtObj[0].Text;
		var str="";
		for (var i = 0; i < txtLen; i++) {
			var _className = txtObj[i].className || "";
			var _style = txtObj[i].style || "";
			var _txt = txtObj[i].Text;
			var _type = txtObj[i].type;
			if (_type == "custom") {
				str += '<div class="al-text ' + _className + ' custom" style="' + _style + '">' + _txt + '</div>';
			} else {
				str += '<p class="al-text ' + _className + '" style="' + _style + '">' + _txt + '</p>';
			}
		}
		$alertObj.find('.content-txt').html(str);
		var _class="exit-popup ";
		if(txt ==  null || txt==""){
			_class+="blank-content "
		}
		$alertObj.find('.modal-alert').addClass(_class);
		var btnTextObj=textObj.buttonText[0].text;
		var t="";
		for(var i=0; i<btnTextObj.length; i++){
			_class=btnTextObj[i].className || "";
			_style=btnTextObj[i].style || "";
				t+='<button type="button" style="'+_style+'" class="ui-button '+_class+'">'+btnTextObj[i].Text+'</button>';
			
		}
		$alertObj.find('.modal-btn').html(t);
		$alertObj.show();
		$alertObj.find('.modal-alert').addClass('bounceIn animated');
		$alertObj.find('.ui-button').on('click', function(){
			if($(this).hasClass('ok-btn')){
				APP.globalMessageOpen=false;
				APP.winWillClose=true;
				//--
				APP.commonFunObj.stopLmsInterval();		
				//--
				window.top.close();
			}
			if($(this).hasClass('cancel-btn') || $(this).hasClass('hide-btn') || $(this).hasClass('no-btn')){
				$alertObj.find('.modal-alert').removeClass('bounceIn animated').addClass('bounceOut animated');
				setTimeout(function(){
					$alertObj.fadeOut();
					APP.globalMessageOpen=false;
				},500);
				
				
			}
		})
		
	}
	_this.showBookmarkPop=function(){
		if(APP.globalMessageOpen){return false;}
		var $alertObj=$('.bookmark-pop');
		$alertObj.find('.modal-alert').removeClass('animated bounceIn bounceOut');
		if($alertObj.find('.modal-alert').length){
			$alertObj.show();
			$alertObj.find('.modal-alert').addClass('bounceIn animated');
			APP.globalMessageOpen=true;
			return false;
		}
		
		$alertObj.html(getAlertWinHtml());
		
		var textObj=APP.globalXmlsObj.screenDataXML.bookmarkPopText[0];
		
		$alertObj.find('.modal-title').html(textObj.title[0].Text);
		var txtObj = textObj.text;
		var txtLen = txtObj.length;
		var txt=txtObj[0].Text;
		var str="";
		for (var i = 0; i < txtLen; i++) {
			var _className = txtObj[i].className || "";
			var _style = txtObj[i].style || "";
			var _txt = txtObj[i].Text;
			var _type = txtObj[i].type;
			if (_type == "custom") {
				str += '<div class="al-text ' + _className + ' custom" style="' + _style + '">' + _txt + '</div>';
			} else {
				str += '<p class="al-text ' + _className + '" style="' + _style + '">' + _txt + '</p>';
			}
		}
		
		$alertObj.find('.content-txt').html(str);
		var _class="bookmark-popup ";
		if(txt ==  null || txt==""){
			_class+="blank-content "
		}
		$alertObj.find('.modal-alert').addClass(_class);
		
		var t="";
		/* for(var i=0; i<btnTextObj.length; i++){
			_class=btnTextObj[i].className || "";
			_style=btnTextObj[i].style || "";
				t+='<button type="button" style="'+_style+'" class="ui-button '+_class+'">'+btnTextObj[i].Text+'</button>';
			
		} */
		//--
			var btnTextObj=textObj.buttonText[0].text;			
			t += '<div class="file-block" >'			
				t+='<input id="file-input" class="input-box " type="file" accept=".data"></input>';
				t+='<button type="button" class="ui-button load-file-btn disabled">'+btnTextObj[1].Text+'</button>';
			t += '</div>';
			t += '<div class="second-block" >'
				t+='<button type="button" class="ui-button create-new-btn">'+btnTextObj[0].Text+'</button>';
			t += '</div>';
		//--
		$alertObj.find('.modal-btn').html(t);
		$alertObj.show();
		$alertObj.find('.modal-alert').addClass('bounceIn animated');
		$alertObj.find('.ui-button').on('click', function(){
			/* if($(this).hasClass('ok-btn')){
				$alertObj.find('.modal-alert').removeClass('bounceIn animated').addClass('bounceOut animated');
				setTimeout(function(){
					$alertObj.fadeOut();
					APP.globalMessageOpen=false;
					APP.navigationObj.loadPage();	
				},500);
							
			}
			if($(this).hasClass('cancel-btn') || $(this).hasClass('hide-btn') || $(this).hasClass('no-btn')){
				$alertObj.find('.modal-alert').removeClass('bounceIn animated').addClass('bounceOut animated');
				setTimeout(function(){
					$alertObj.fadeOut();
					APP.globalMessageOpen=false;
					
					APP.navData.moduleId=0;
					APP.navData.subModuleId=0;
					APP.navData.pageId=0;
					
					APP.navigationObj.loadPage();
				},500);
				
				
			} */
			if($(this).hasClass('load-file-btn')){
				$alertObj.find('.modal-alert').removeClass('bounceIn animated').addClass('bounceOut animated');
				setTimeout(function(){
					$alertObj.fadeOut();
					APP.globalMessageOpen=false;

					const input = document.getElementById('file-input');
					const file = input.files[0];
					try {
						const reader = new FileReader();
						reader.onload = function() {						
							const contents = reader.result;
							//console.log(contents);
							let preData = JSON.parse(contents);
							input.value = null;
							$(this).addClass('disabled');
							if(preData != null && preData != ''){
								APP.courseDataObj.createCourseData(preData);
								//--jump to last screen
								APP.navData.moduleId=0;
								APP.navData.subModuleId=0;
								APP.navData.pageId=3;
								APP.navigationObj.loadPage();
							}else{
								APP.courseDataObj.createCourseData('');
								//-- load first screen
								APP.navData.moduleId=0;
								APP.navData.subModuleId=0;
								APP.navData.pageId=0;
								APP.navigationObj.loadPage();
							}
							updateCandidateData();
						};
						reader.readAsText(file);
					} catch (error) {
						alert('Unable to Read Questionnaire File');
					}
					
				},500);
							
			}
			if($(this).hasClass('create-new-btn') || $(this).hasClass('hide-btn') || $(this).hasClass('no-btn')){
				$alertObj.find('.modal-alert').removeClass('bounceIn animated').addClass('bounceOut animated');
				setTimeout(function(){
					$alertObj.fadeOut();
					APP.globalMessageOpen=false;

					APP.courseDataObj.createCourseData('');
					

					APP.navData.moduleId=0;
					APP.navData.subModuleId=0;
					APP.navData.pageId=0;
					
					APP.navigationObj.loadPage();
					updateCandidateData();
				},500);
				
				
			}
		})
		
	}
	_this.showApiFailPop=function(){
		if(APP.globalMessageOpen){return false;}
		var $alertObj=$('.api-fail-pop');
		$alertObj.find('.modal-alert').removeClass('animated bounceIn bounceOut');
		if($alertObj.find('.modal-alert').length){
			$alertObj.show();
			$alertObj.find('.modal-alert').addClass('bounceIn animated');
			APP.globalMessageOpen=true;
			return false;
		}
		
		$alertObj.html(getAlertWinHtml());
		
		var textObj=APP.globalXmlsObj.screenDataXML.apiFailPopText[0];
		
		$alertObj.find('.modal-title').html(textObj.title[0].Text);
		var txtObj = textObj.text;
		var txtLen = txtObj.length;
		var txt=txtObj[0].Text;
		var str="";
		for (var i = 0; i < txtLen; i++) {
			var _className = txtObj[i].className || "";
			var _style = txtObj[i].style || "";
			var _txt = txtObj[i].Text;
			var _type = txtObj[i].type;
			if (_type == "custom") {
				str += '<div class="al-text ' + _className + ' custom" style="' + _style + '">' + _txt + '</div>';
			} else {
				str += '<p class="al-text ' + _className + '" style="' + _style + '">' + _txt + '</p>';
			}
		}
		$alertObj.find('.content-txt').html(str);
		var _class="api-popup ";
		if(txt ==  null || txt==""){
			_class+="blank-content "
		}
		$alertObj.find('.modal-alert').addClass(_class);
		var btnTextObj=textObj.buttonText[0].text;
		var t="";
		for(var i=0; i<btnTextObj.length; i++){
			_class=btnTextObj[i].className || "";
			_style=btnTextObj[i].style || "";
				t+='<button type="button" style="'+_style+'" class="ui-button '+_class+'">'+btnTextObj[i].Text+'</button>';
			
		}
		$alertObj.find('.modal-btn').html(t);
		$alertObj.show();
		$alertObj.find('.modal-alert').addClass('bounceIn animated');
		$alertObj.find('.ui-button').on('click', function(){
			if($(this).hasClass('ok-btn')){
				APP.globalMessageOpen=false;
				APP.winWillClose=true;
				//--
				APP.commonFunObj.stopLmsInterval();		
				//--
				window.top.close();
			}
			if($(this).hasClass('cancel-btn') || $(this).hasClass('hide-btn') || $(this).hasClass('no-btn')){
				$alertObj.find('.modal-alert').removeClass('bounceIn animated').addClass('bounceOut animated');
				setTimeout(function(){
					$alertObj.fadeOut();
					APP.globalMessageOpen=false;
				},500);
			}
		})
		
	}
	
	_this.showNetworkFailPop=function(){
		if(APP.globalMessageOpen){return false;}
		var $alertObj=$('.network-fail-pop');
		$alertObj.find('.modal-alert').removeClass('animated bounceIn bounceOut');
		if($alertObj.find('.modal-alert').length){
			$alertObj.show();
			$alertObj.find('.modal-alert').addClass('bounceIn animated');
			APP.globalMessageOpen=true;
			return false;
		}
		
		$alertObj.html(getAlertWinHtml());
		
		var textObj=APP.globalXmlsObj.screenDataXML.networkFailPopText[0];
		
		$alertObj.find('.modal-title').html(textObj.title[0].Text);
		var txtObj = textObj.text;
		var txtLen = txtObj.length;
		var txt=txtObj[0].Text;
		var str="";
		for (var i = 0; i < txtLen; i++) {
			var _className = txtObj[i].className || "";
			var _style = txtObj[i].style || "";
			var _txt = txtObj[i].Text;
			var _type = txtObj[i].type;
			if (_type == "custom") {
				str += '<div class="al-text ' + _className + ' custom" style="' + _style + '">' + _txt + '</div>';
			} else {
				str += '<p class="al-text ' + _className + '" style="' + _style + '">' + _txt + '</p>';
			}
		}
		$alertObj.find('.content-txt').html(str);
		var _class="network-popup ";
		if(txt ==  null || txt==""){
			_class+="blank-content "
		}
		$alertObj.find('.modal-alert').addClass(_class);
		var btnTextObj=textObj.buttonText[0].text;
		var t="";
		for(var i=0; i<btnTextObj.length; i++){
			_class=btnTextObj[i].className || "";
			_style=btnTextObj[i].style || "";
				t+='<button type="button" style="'+_style+'" class="ui-button '+_class+'">'+btnTextObj[i].Text+'</button>';
			
		}
		$alertObj.find('.modal-btn').html(t);
		$alertObj.show();
		$alertObj.find('.modal-alert').addClass('bounceIn animated');
		$alertObj.find('.ui-button').on('click', function(){
			if($(this).hasClass('ok-btn')){
				$alertObj.find('.modal-alert').removeClass('bounceIn animated').addClass('bounceOut animated');
				setTimeout(function(){
					$alertObj.fadeOut();
					APP.globalMessageOpen=false;
				},500);
			}
			if($(this).hasClass('cancel-btn') || $(this).hasClass('hide-btn') || $(this).hasClass('no-btn')){
				$alertObj.find('.modal-alert').removeClass('bounceIn animated').addClass('bounceOut animated');
				setTimeout(function(){
					$alertObj.fadeOut();
					APP.globalMessageOpen=false;
				},500);
			}
		})		
	}
	_this.showResetDataPop=function(){
		if(APP.globalMessageOpen){return false;}
		var $alertObj=$('.reset-data-pop');
		$alertObj.find('.modal-alert').removeClass('animated bounceIn bounceOut');
		if($alertObj.find('.modal-alert').length){
			$alertObj.show();
			$alertObj.find('.modal-alert').addClass('bounceIn animated');
			APP.globalMessageOpen=true;
			return false;
		}
		
		$alertObj.html(getAlertWinHtml());
		
		var textObj=APP.globalXmlsObj.screenDataXML.resetDataPopText[0];
		
		$alertObj.find('.modal-title').html(textObj.title[0].Text);
		var txtObj = textObj.text;
		var txtLen = txtObj.length;
		var txt=txtObj[0].Text;
		var str="";
		for (var i = 0; i < txtLen; i++) {
			var _className = txtObj[i].className || "";
			var _style = txtObj[i].style || "";
			var _txt = txtObj[i].Text;
			var _type = txtObj[i].type;
			if (_type == "custom") {
				str += '<div class="al-text ' + _className + ' custom" style="' + _style + '">' + _txt + '</div>';
			} else {
				str += '<p class="al-text ' + _className + '" style="' + _style + '">' + _txt + '</p>';
			}
		}
		$alertObj.find('.content-txt').html(str);
		var _class="reset-data-popup ";
		if(txt ==  null || txt==""){
			_class+="blank-content "
		}
		$alertObj.find('.modal-alert').addClass(_class);
		var btnTextObj=textObj.buttonText[0].text;
		var t="";
		for(var i=0; i<btnTextObj.length; i++){
			_class=btnTextObj[i].className || "";
			_style=btnTextObj[i].style || "";
				t+='<button type="button" style="'+_style+'" class="ui-button '+_class+'">'+btnTextObj[i].Text+'</button>';
			
		}
		$alertObj.find('.modal-btn').html(t);
		$alertObj.show();
		$alertObj.find('.modal-alert').addClass('bounceIn animated');
		$alertObj.find('.ui-button').on('click', function(){
			if($(this).hasClass('ok-btn')){
				$alertObj.find('.modal-alert').removeClass('bounceIn animated').addClass('bounceOut animated');
				
				setTimeout(function(){
					$alertObj.fadeOut();
					APP.globalMessageOpen=false;
					APP.commonFunObj.resetData();
				},500);
				
			}
			if($(this).hasClass('cancel-btn') || $(this).hasClass('hide-btn') || $(this).hasClass('no-btn')){
				$alertObj.find('.modal-alert').removeClass('bounceIn animated').addClass('bounceOut animated');
				setTimeout(function(){
					$alertObj.fadeOut();
					APP.globalMessageOpen=false;
				},500);
			}
		})		
	}
		
	_this.insertDelay = function(amount){
		vDate = new Date() 
		while (1)
		{
			vMill=new Date() 
			vDiff = vMill-vDate;
			if( vDiff > amount ) 
				break;
		}
	}
	_this.isScorm = function(){
		var scrom=false;
		//-- 1: scorm1.2, 2:scorm2004
		if(APP.configObj.tracking.complianceType==1 || APP.configObj.tracking.complianceType==2){
			scrom = true;
		}
		return scrom;
		//return true;
	} 
	_this.isOnlineHttp = function(){
		var isHttp = false;	
		isHttp = String(window.location).indexOf("http") >= 0 || String(window.location).indexOf("https") >= 0
		return isHttp;
		//return true;
	}
	
	_this.checkConnection=function(callBack){
		document.getElementById('net-con').innerHTML +=
			'<img id="testImage" style="display: none;" ' +
			'src="framework/images/for_network_check.png?' + Math.random() + '" ' +
			'onerror="testConnectionCallback(false);" ' +
			'onload="testConnectionCallback(true);">';

		testConnectionCallback = function(result){
			callBack(result);
			//alert("called")
			var element = document.getElementById('testImage');
			if(element!=null){
			element.parentNode.removeChild(element);
			}
		}    
	}
	_this.documentScrollTop = function() {
		return (document.documentElement.scrollTop + document.body.scrollTop
		== document.documentElement.scrollTop) ?
		document.documentElement.scrollTop : document.body.scrollTop;
	}
	
	_this.isElementInView = function (elem,dir) {
		var docViewTop = _this.documentScrollTop();
		var docViewBottom = (window.innerHeight + docViewTop);

		var elemTop = $(elem).offset().top;
		var elemBottom = elemTop + ($(elem).height() / 2);
		var elemBottom2 = elemTop + $(elem).height();
	   
		if(dir == 'top'){		
			if((elemTop <= docViewTop && elemBottom2 >= docViewTop)){		
				return (elemBottom2 -docViewTop) > (window.innerHeight/2);	
			}else if(elemTop > docViewTop && elemBottom2 >= docViewTop){			
				return (docViewBottom - elemTop) > (window.innerHeight/2);			
			}else{
				return false;
			}				
		}else{
			return ((elemBottom <= docViewBottom) && (elemTop >= docViewTop ));
		}	
	}

	_this.scrollToElement = function ($el, showAnimation, type){        
		if($el.length<=0){return false;}
		if (type == undefined){
		   type = "bottom";
		}
		var marginTop;
   
		var viewportTop = _this.documentScrollTop();
		
		var viewportBottom = viewportTop + ($(window).height());
		
		var elOffsetTop = $el.offset().top;
					
		if (type == "bottom"){
			marginTop = (elOffsetTop + $el.outerHeight()+10);
			//marginTop = (elOffsetTop + $el.outerHeight()+10);
			if (marginTop < viewportTop || marginTop > $(window).height()){
				type = "top";
			}
		}
		if (type == "top"){
			marginTop = elOffsetTop - ($('.header').outerHeight(true, true) - 15);
		}
		if(showAnimation){
			$("html, body").stop().animate({scrollTop:marginTop}, 1000, function() { 
			
			});	  
		}else{
			$("html, body").scrollTop(marginTop);
		}
    }
	_this.startLmsInterval = function(){	
		APP.commonFunObj.stopLmsInterval();	
		//console.log('startLmsInterval...')
		lmsInterval = setInterval(function(){APP.dataComObj.updateUserData()}, lmsIntervalTime);
	}
	_this.stopLmsInterval = function(){
		//console.log('stopLmsInterval...')
		clearInterval(lmsInterval);
	}
	_this.removeVideoMediaElement = function(){
		if($('video').length>0){
			$('video').each(function() {
				player = $(this).data("mediaelementplayer");
				player.remove();
			});
		}
	}
	_this.getNumberTxt = function (_currIndx, _actualNo){
		var inx = (_currIndx+1);
		if(_actualNo === undefined) {
			  _actualNo = false;
		   }
		if(_actualNo == true){
			inx = _currIndx;
		}
		var num = APP.globalXmlsObj.screenDataXML.numbers[0].number[inx];
			if(num == null || num == undefined){
				num = inx;
			}else{
				num = num.Text;
			}
		return num;
	}
	_this.resetData = function(){		
		if (typeof(Storage) !== "undefined") {		
		 localStorage.removeItem("ia_lang");
		 localStorage.removeItem("ia_dir");
		 localStorage.removeItem("ia_pageDataArray");
		 localStorage.removeItem("ia_pageCompleteArray");
		 localStorage.removeItem("ia_interviewQuesObj");
		 localStorage.removeItem("ia_courseBookmark");
		 //refresh the page and load
		 APP.winWillClose=true;
		location.reload(true);					
		}
				 
	 }
	function getAlertWinHtml(){
		var str="";
		str+='<div class="modal-alert bounceIn">';
			str+='<div class="modal-titlebar">';
				str+='<span class="modal-title"></span>';			
			str+='</div>';
			str+='<div class="modal-content">';
				str+='<div class="display-table text-panel">';
				
					str+='<div class="display-cell content-txt">';
						
					str+='</div>';
				str+='</div>';
			str+='</div>';
			str+='<div class="modal-btnpane">';
				str+='<div class="modal-btn"></div>';
			str+='</div>';
		str+='</div>';
		return str;
	}
}



(function ($) {
	$.fn.shuffle = function () {
		var parent = this.parent();
		var divs = parent.children();
		while (divs.length) {
			parent.append(divs.splice(Math.floor(Math.random() * divs.length), 1)[0]);
		}
	};
})(jQuery);

String.prototype.replaceAll = function(search, replacement) {
    var target = this;
    return target.split(search).join(replacement);
};

if (typeof Object.assign !== 'function') {
  // Must be writable: true, enumerable: false, configurable: true
  Object.defineProperty(Object, "assign", {
    value: function assign(target, varArgs) { // .length of function is 2
      'use strict';
      if (target === null || target === undefined) {
        throw new TypeError('Cannot convert undefined or null to object');
      }

      var to = Object(target);

      for (var index = 1; index < arguments.length; index++) {
        var nextSource = arguments[index];

        if (nextSource !== null && nextSource !== undefined) { 
          for (var nextKey in nextSource) {
            // Avoid bugs when hasOwnProperty is shadowed
            if (Object.prototype.hasOwnProperty.call(nextSource, nextKey)) {
              to[nextKey] = nextSource[nextKey];
            }
          }
        }
      }
      return to;
    },
    writable: true,
    configurable: true
  });
}