function CourseData() {
	var _this = this;
	var pageDataArray=[];
	var pageCompleteArray=[];
	var inputData = {}
	_this.createCourseData=function(_str){
		//console.log('createCourseData.....');
		if(_str=="" || _str==null){
			initData();
			
		}else{
			var prevData=_str.split('-#-');
			APP.configObj.language.lang=prevData[0];
			APP.configObj.language.dir=prevData[1];
			pageCompleteArray=prevData[2].split(',');
			APP.interviewQuesObj=JSON.parse(prevData[3]);			
			APP.courseBookmark=prevData[4];
					
		}
				
	}
	_this.updateSuspendData=function(){
		//if(APP.commonFunObj.isScorm()){
			var str=APP.configObj.language.lang+"-#-"+APP.configObj.language.dir+"-#-"+pageCompleteArray.toString()+"-#-"+JSON.stringify(APP.interviewQuesObj)+"-#-"+APP.courseBookmark;
			//console.log('updateSuspendData: '+str);
			return str;
		//}
	}
	_this.sendDataToLocalStorage = function (){
		if(!APP.commonFunObj.isScorm()){
			if (typeof(Storage) !== "undefined") {
				//console.log('updateSuspendData local storage')
				localStorage.setItem("ia_lang", APP.configObj.language.lang);
				localStorage.setItem("ia_dir", APP.configObj.language.dir);
				
				localStorage.setItem("ia_pageDataArray", JSON.stringify(pageDataArray));
				localStorage.setItem("ia_pageCompleteArray", JSON.stringify(pageCompleteArray));
				
				localStorage.setItem("ia_interviewQuesObj", JSON.stringify(APP.interviewQuesObj));
				localStorage.setItem("ia_courseBookmark", APP.courseBookmark);
			}
		}
	}
	_this.retriveDataFromLocalStorage = function (){
		//console.log('retriveDataFromLocalStorage local storage')
		pageDataArray=JSON.parse(localStorage.getItem("ia_pageDataArray"));
		pageCompleteArray=JSON.parse(localStorage.getItem("ia_pageCompleteArray"));
		if(pageDataArray==null || pageCompleteArray==null){
			initData();
		}
		var lang = localStorage.getItem("ia_lang");
		if(lang != null){
			APP.configObj.language.lang = lang;
		}
		var dir = localStorage.getItem("ia_dir");
		if(dir != null){
			APP.configObj.language.dir = dir;
		}
		var interviewQueObj = JSON.parse(localStorage.getItem("ia_interviewQuesObj"));
		if(interviewQueObj != null){
			APP.interviewQuesObj = interviewQueObj
		}
		var courseBookmark = localStorage.getItem("ia_courseBookmark");
		if(courseBookmark != null){
			APP.courseBookmark = courseBookmark;
		}
	}
	_this.updatePageData=function(_val){
		var idx=APP.navData.currentPageObj.pageIndex;
		pageDataArray[idx]=_val;
		//console.log("pageDataArray: "+pageDataArray);
	}
	_this.updatePageCompletion=function(_val){
		var idx=APP.navData.currentPageObj.pageIndex;
		pageCompleteArray[idx]=_val;
		APP.dataComObj.updateUserData();
		if(_val == 2){
			$(document).trigger(APP.eventObj.ON_PAGE_COMPLETE);
		}
		//console.log("pageCompleteArray: "+pageCompleteArray);
	}
	_this.isPageComplete = function(){
		var idx=APP.navData.currentPageObj.pageIndex;
		var dd = pageCompleteArray[idx];
		var complete = false;
		if(dd == 2) {
			complete = true;
		}
		return complete;
	}
	_this.isAllPageCompleted = function(){
		var complete = true;
		for(var i=0; i<pageCompleteArray.length; i++){
			if(pageCompleteArray[i] != 2){
				complete = false;
			}
		}
		return complete;
	}
	_this.getCourseComPercentage = function(){
		var com =0;
		var tot = pageCompleteArray.length;
		percentage = 0;
		for(var i=0; i<pageCompleteArray.length; i++){
			if(pageCompleteArray[i] == 2){
				com ++;
			}
		}
		percentage = Math.round((com / tot) * 100);
		return percentage;
	}
	_this.resetInterviewQuesObj = function(){
		APP.interviewQuesObj={
			candidateDetail:{},
			selectedSkill:[],
			typedSkill:[],
			typedQues:[],
			generalQues:[],
			additionalInfo:{},
			selectedRole:{role:'pm',inx:0}
		}
		$(document).trigger(APP.eventObj.ON_PAGE_UPDATE);
	}
	function initData (){
		pageDataArray=[];
		pageCompleteArray=[];

		var modObj=APP.globalXmlsObj.navigationXML.module;
		
		for(var i=0; i<modObj.length; i++){
			var subModObj=APP.globalXmlsObj.navigationXML.module[i].module;
			for(var j=0; j<subModObj.length; j++){
				var pageObj=APP.globalXmlsObj.navigationXML.module[i].module[j].page;
				for(var k=0; k<pageObj.length; k++){
					pageDataArray.push(0);
					pageCompleteArray.push(0);
				}
			}
		}
		_this.resetInterviewQuesObj();
		updateCandidateData();
	}
}