
//-- for seperate screen
if(window.opener!= null){
	var APP = Object.assign({}, window.opener.APP);
}

var formObj = null;
var page = null;
let queryString = '';
/* var winWd = window.screen.availWidth;
var winHt = window.screen.availHeight;
window.moveTo(0, 0);
window.resizeTo(winWd, winHt);
 */
$(document).ready(function () {
	/* $(document).bind("contextmenu", function (e) {
		e.preventDefault();
	}); */
	if(window.opener!= null){
		formObj = APP.interviewQuesObj;
		init();
	}
});
function init(){
	getHtml();
	queryString = getQueryStringParams();
	
	page = new FinalQuesForm();
	page.start({	
		xmlNode: APP.globalXmlsObj.screenDataXML.finalQuesFormScreen[0],
		type:'final-ques-screen',
		mode:'editable'
	})
	
	
	$(document).on('click','.print-screen', function (e) {
		if($(this).hasClass('disabled')){return false;}	
		var txt = APP.globalXmlsObj.screenDataXML.commonText[0].warningTxt[0].Text;
		if(validateFinalScore()){
			window.print();
		}else{
			if (confirm(txt)) {
				window.print();
			} else {
				
			}
		}
	});
	/* image: { type: 'jpeg', quality: 0.98 },
			html2canvas:  { scale: 1}, */
	$(document).on('click','.download-pdf-screen', function (e) {
		if($(this).hasClass('disabled')){return false;}
		var txt = APP.globalXmlsObj.screenDataXML.commonText[0].warningTxt[0].Text;
		if(validateFinalScore()){
			applyPdfConverter();
		}else{
			if (confirm(txt)) {
				applyPdfConverter();
			  } else {
				
			  }
		}		
		
	});
	$(document).on('click','.download-doc-screen', function (e) {
		if($(this).hasClass('disabled')){return false;}
		$('.hide-on-print').hide();
		$('.hide-on-docx').hide();
		$('.score-details').hide();
		$('.drop-down-btn.default-selected span').hide();
		$('.dropDown').hide();
		

		createDocFile({
			htmlString: document.documentElement.outerHTML,
			filePath: './example.docx'
		})	
		
	});

	
	
	if(queryString.mode == 'doc'){
		$('.hide-on-print').hide();
		$('.hide-on-docx').hide();
		$('.score-details').hide();
		$('.drop-down-btn.default-selected span').hide();
		$('.dropDown').hide();
		
		createDocFile({
			htmlString: document.documentElement.outerHTML,
			filePath: './interview.docx'
		})	


	}
}
function getQueryStringParams(){
	var url = document.location.href;
	var qs = url.substring(url.indexOf('?') + 1).split('&');
	for(var i = 0, result = {}; i < qs.length; i++){
		qs[i] = qs[i].split('=');
		result[qs[i][0]] = decodeURIComponent(qs[i][1]);
	}
	return result;
}
//html2canvas:  {dpi: 192, letterRendering: true},
function applyPdfConverter(){
	$('.hide-on-print').hide();
	$('.drop-down-btn.default-selected span').hide();
	var PDFElement= $('#final-ques-screen_panel')[0];
		var opt = {
		filename: 'new_interview_guide.pdf',
		margin: [15,10, 15, 10],
		pagebreak: { mode: 'css'},
		image: { type: 'jpeg', quality: 1 },		
		html2canvas: {scale: 2, logging: true},
		jsPDF: { unit: 'mm', format: 'a4', orientation: 'portrait' }
		};
		//html2pdf(PDFElement, opt);
		html2pdf().set(opt).from(PDFElement).save().then(function(){				
			$('.drop-down-btn.default-selected span').show();
			$('.hide-on-print:not(.drop-down-menu)').show();
			$('.hide-on-print.drop-down-menu').attr('style','');
		});
}
function validateFinalScore(){
		
	//console.log('APP.finalScoreArr: '+APP.finalScoreArr);
	var allSelected = true;
	for(var i=0; i<APP.finalScoreArr.length; i++){
		if(APP.finalScoreArr[i].isAllSelected == false){
			allSelected = false;
			break;
		}
	}	
	return allSelected;
		
}
function getHtml(){
	var str ='';
	str+='<div class ="center-div download-form">';
		str+='<div id ="page-container" ></div>';
	str+='</div>';
	$('body').html(str);
}

async function createDocFile(_obj){
	//console.log('in create doc....');
	var converted = htmlDocx.asBlob(_obj.htmlString);
	let t= APP.interviewQuesObj.candidateDetail.position || '';
	let fileName = prompt("Please enter file name", t);
	if(fileName != null){
		saveAs(converted, fileName+'.docx');
	}		
	

  	setTimeout(function(){
		window.top.close();
	},500);


	
	/* const fileBuffer = await HTMLtoDOCX(_obj.htmlString, null, {
		table: { row: { cantSplit: true } },
		footer: true,
		pageNumber: true,
	});

	saveAs(fileBuffer, 'html-to-docx.docx'); */
	  
	/* (async () => {

		const fileBuffer = await HTMLtoDOCX(_obj.htmlString, null, {
	  
		  table: { row: { cantSplit: true } },
	  
		  footer: true,
	  
		  pageNumber: true,
	  
		});
	  
	  
		fs.writeFile(_obj.filePath, fileBuffer, (error) => {
	  
		  if (error) {
	  
			console.log('Docx file creation failed');
	  
			return;
	  
		  }
	  
		  console.log('Docx file created successfully');
	  
		});
	  
	}); */
}