function GetHtmlStructure() {
	var _this = this;
	
	_this.getCommonBtn = function(_obj){
		var str='';
		var className ='';
		var btnObj = null;
		if(_obj){
			if(_obj.className){
				className = _obj.className; 
			}
			if(_obj.btnObj){
				btnObj = _obj.btnObj; 
			}
		}
				
		if(btnObj == null){
			return '';
		}
					
		var _style = btnObj[0].style || "";
		var _className = btnObj[0].className || "";	
			
		 str+='<div class="btn-panel common '+className+'_div">'	
			if(btnObj[0].href){
			 str+='<a class="btn '+className+' '+_className+'" href="'+btnObj[0].href+'" style="'+_style+'" target="_blank">'
			}else{			 
				str+='<a class="btn '+className+' '+_className+'" href="javascript:void(0);" style="'+_style+'">'
			}	
				if(btnObj[0].extraIcon){
					str+='<span class="btn-icon font-icon extra-icon display-cell">'+btnObj[0].extraIcon[0].Text+'</span>';
				}
				if(btnObj[0].title){
					str+='<span class="btn-txt display-cell"><p>'+btnObj[0].title[0].Text+'</p></span>';
				}
				if(btnObj[0].icon){
					str+='<span class="btn-icon font-icon display-cell">'+btnObj[0].icon[0].Text+'</span>';
				}
			 str+='</a>';
		 str+='</div>';
		 return str;
	}
	
	_this.getCandidateScreen = function(){
		var str='';
		var screenObj = APP.globalXmlsObj.screenDataXML.candidateScreen;
		//var _bgstyle = screenObj[0].bgImage[0].style || "";
		var _nameTxt ='';
		var _posTxt = '';
		if(APP.interviewQuesObj.candidateDetail){
			if(APP.interviewQuesObj.candidateDetail.name !=null){
				_nameTxt = APP.interviewQuesObj.candidateDetail.name;
			}
			if(APP.interviewQuesObj.candidateDetail.position !=null){
				_posTxt = APP.interviewQuesObj.candidateDetail.position;
			}
		}
		str+='<div class=" page-panel" >';
				str += '<div class="swiper-container">';
				   str += ' <div class="swiper-wrapper">';
					  str += '<div class="swiper-slide"><div class="bg-img-box background-img" style="background-image:url(content/images/intro/image2.jpg)" ></div></div>';
					  str += '<div class="swiper-slide"><div class="bg-img-box background-img" style="background-image:url(content/images/intro/image1.jpg)" ></div></div>';
					  str += '<div class="swiper-slide"><div class="bg-img-box background-img" style="background-image:url(content/images/intro/image3.jpg)" ></div></div>';
					  str += '<div class="swiper-slide"><div class="bg-img-box background-img" style="background-image:url(content/images/intro/image4.jpg)" ></div></div>';
					  str += '<div class="swiper-slide"><div class="bg-img-box background-img" style="background-image:url(content/images/intro/image5.jpg)" ></div></div>';
					  str += '<div class="swiper-slide"><div class="bg-img-box background-img" style="background-image:url(content/images/intro/image6.jpg)" ></div></div>';
					  				  
				   str += ' </div>';
				str += '</div>';
				str+='<div class="form">';
					/* str+='<p class="form-title name">'+screenObj[0].candidateNameTxt[0].Text+'</p>';		
					str+='<input class="text-area input-box candidate-name" maxlength="100" data-id="candidate-name" type="text" value="'+_nameTxt+'"></input>'; */

					str+='<p class="form-title position">'+screenObj[0].positionTxt[0].Text+'</p>';		
					str+='<input class="text-area input-box candidate-position" maxlength="100" data-id="candidate-position" type="text" value="'+_posTxt+'"></input>';
					if(screenObj[0].roles){
						str+='<p class="form-title role">'+screenObj[0].roleTxt[0].Text+'</p>';
						str+='<div class="segmented-control" style="width: 100%; color:#1E32FA;">';
							for(var i=0; i<screenObj[0].roles[0].roleButton.length; i++){
								var curr = screenObj[0].roles[0].roleButton[i];
								var isSelected = false;								
								if(APP.interviewQuesObj.selectedRole!= null){
									var selectedRole = APP.interviewQuesObj.selectedRole.role;
									if(selectedRole !=null && selectedRole!=''){
										if(selectedRole == curr.value){
											isSelected = true;
										}else{
											isSelected = false;
										}
									}else{
										isSelected = false;
									}
								}
								if(isSelected){
									str+='<input type="radio" name="role-btn" class="role-btn" id="role-'+i+'" data-role="'+curr.value+'" data-inx="'+i+'" checked="checked">';
								}else{
									str+='<input type="radio" name="role-btn" class="role-btn" id="role-'+i+'" data-role="'+curr.value+'" data-inx="'+i+'">';
								}
							}
							for(var i=0; i<screenObj[0].roles[0].roleButton.length; i++){
								var curr = screenObj[0].roles[0].roleButton[i];	
								str+='<label for="role-'+i+'" data-value="'+curr.Text+'">'+curr.Text+'</label>';
							}
							
						str+='</div>';
					}
				str+='</div>';
			
		str+='</div>';
		return str;
	}

	
	
	_this.getSectionScreen = function(){
		var str='';
		var screenObj = APP.globalXmlsObj.screenDataXML.sectionsScreen;
		str += '<div class="page-panel">';			
		var btns = screenObj[0].section;
			for(var i=0; i<btns.length; i++){
				str+='<div class="btn-panel "><a class="btn btn_section section_'+i+'" href="javascript:void(0);" data-jump="0_0_'+i+'">';
					var num = APP.globalXmlsObj.screenDataXML.numbers[0].number[(i+1)];
						if(num == null || num == undefined){
							num = (i+1);
						}else{
							num = num.Text;
						}
					str+='<span class="btn-icon display-cell">'+num+'</span>';
				
					str+='<span class="btn-txt display-cell"><p class="txt">'+btns[i].Text+'</p><p class="status">'+screenObj[0].noneTxt[0].Text+'</p></span>';
			 str+='</a></div>';	
			}
		str += '</div>';
		
		return str;
	}
	_this.scoreTable = function(_obj){
		var str = '';
		var scoreTableObj = APP.globalXmlsObj.screenDataXML.scoreTable;
		var className ='';
		if(_obj){
			if(_obj.className){
				className = _obj.className; 
			}
		}
		 if(scoreTableObj != null){
			 /* 1 */str+='<div class="score-table '+className+'">';					
				/* 2 */str+='<div class="score-title ">';					
					var _style = scoreTableObj[0].title[0].style || "";
					var _className = scoreTableObj[0].title[0].className || "";
					str+='<span class="txt '+_className+'" style ="'+_style+'">'+scoreTableObj[0].title[0].Text+'</span>';		
				/* 2 */str+='</div>';
				/* 3 */str+='<div class="score-points display-table">';
				var scoreObj = scoreTableObj[0].scores[0].score
					for(var i=0; i<scoreObj.length; i++){
						var currScoreObj =scoreObj[i]; 
						/* 4 */str+='<div class="display-cell">';
							var _style = currScoreObj.point[0].style || "";
							var _className = currScoreObj.point[0].className || "";
							str+='<div class="point '+_className+'" style ="'+_style+'"><p>'+currScoreObj.point[0].Text+'</p></div>';
							/* 5 */str+='<div class="desc">';
								var scoreDescObj = currScoreObj.description[0];
								
								 var _style = scoreDescObj.style || "";
								var _className = scoreDescObj.className || "";
								str+= '<p class ="txt '+_className+'" style="'+_style+'">'+scoreDescObj.Text+'</p>';
							 
							/* 5 */str+='</div>';
						/* 4 */str+='</div>';
					}
				/* 3 */str+='</div>';
			 /* 1 */str+='</div>';
		 }
		return str;
	}
	
	_this.selectedSkillQuestions = function(_obj){
		var str = '';
		var skillObj = APP.interviewQuesObj.selectedSkill;
		var skillXmlNode = APP.globalXmlsObj.globalXML.skills[0];	
		
		var className ='';
		var mode ='normal';
		if(_obj){
			if(_obj.className){
				className = _obj.className; 
			}		
			if(_obj.mode){
				mode = _obj.mode; 
			}
		}
		/* 1 */str+='<div class="skills-panel '+className+' mode_'+mode+'">';		  
		for(var k=0; k<skillObj.length; k++){			
			for(var l=0; l<skillObj[k].length; l++){
				var currSkillObj = skillObj[k][l];	
				var currGroupId =  currSkillObj.groupId
				var currSkillId =  currSkillObj.id
				var skill = skillXmlNode.group[currGroupId].skill[currSkillId];
				
				var allQueObj = skill.questions[0].question;
				var Qlen = allQueObj.length;
				
				if(currSkillObj.pick == false){
					continue;
				}
				//--for skipping unselected question in skill
				if(mode == 'static' || mode == 'editable'){
					var static_count = 0;
					var isAvl = true;
					for(var p=0; p<Qlen; p++){
						var curr = currSkillObj.pickQ
						if(curr.length){
							if(currSkillObj.pickQ[p].pick == false){
								static_count++;						
							}
						}else{
							isAvl = false
						}
					}
					if(static_count >= Qlen || !isAvl){
						continue;
					}
				}
				
				var _style = skill.style || "";
				var _className = skill.className || "";
				
		/* 2 */str+='<div class="skill-panel skill-panel_'+currGroupId+'-'+currSkillId+' '+_className+'" style="'+_style+'" data-groupid="'+currGroupId+'" data-id="'+currSkillId+'">'
					str+='<div class="head">'
						if(skill.icon){
							var _style = skill.icon[0].style || "";
							var _className = skill.icon[0].className || "";
							str+= '<span class ="font-icon icon '+_className+'" style="'+_style+'">'+skill.icon[0].Text+'</span>';
						}
						if(skill.title){
							var _style = skill.title[0].style || "";
							var _className = skill.title[0].className || "";
							str+= '<span class ="name '+_className+'" style="'+_style+'"><b>'+skill.title[0].Text+'</b></span>';
						}
						if(mode == 'editable'){
							str+= '<span class ="score-details"></span>';
						}
					str+='</div>';
					if(skill.description){
						var _style = skill.description[0].style || "";
						var _className = skill.description[0].className || "";
						str+= '<div class ="desc '+_className+'" style="'+_style+'">'
							var decLen = skill.description[0].text.length;
							 str+='<div class="desc-panel">'
							 for(var j=0; j<decLen; j++){
								var _style = skill.description[0].text[j].style || "";
								var _className = skill.description[0].text[j].className || "";
								str+= '<p class ="txt '+_className+'" style="'+_style+'">'+skill.description[0].text[j].Text+'</p>';
							 }
							  str+='</div>';
						str+= '</div>'
					}
				//-- selectAllbutton
				if(mode == '' || mode == 'normal' || mode == 'selectable'){
				 var returned = APP.GetHtmlStructObj.getCommonBtn({
						className:'margin-top select-all-btn',
						btnObj:APP.globalXmlsObj.screenDataXML.commonText[0].selectAllBtn 
					}); 
					if(returned !=''){
						str+=returned;
					}
				}
			/* 3 */str+='<div class="questions">'
						
						var static_count = 0;
						for(var q=0; q<Qlen; q++){	
							if(mode == '' || mode == 'normal' || mode == 'selectable'){
								//--only create first time
								if(currSkillObj.pickQ.length < Qlen){
									  if(q==0){
										 currSkillObj.pickQ = []; 
									  }
									  var temp = {
										  id:q,
										  pick:false
									  }
									  currSkillObj.pickQ.push(temp);
								}
							}else{
								var curr = currSkillObj.pickQ
								if(curr.length){
									if(currSkillObj.pickQ[q].pick == false){
										continue;
									}
								}else{
									continue;
								}
							}
							var currQue =  allQueObj[q];			
							var _style = skill.style || "";
							var _className = skill.className || "";
							
							if(mode == '' || mode == 'normal' || mode == 'selectable'){
								str+= '<div class="btn-panel"><a class="btn choice-btn click-item '+_className+' choice-btn_'+currGroupId+'_'+currSkillId+'_'+q+'" href="javascript:void(0);" data-groupid="'+currGroupId+'" data-id="'+currSkillId+'" data-subid="'+q+'" style="'+_style+'">';
								str+='<div class="btn-icon-div display-cell">';
									str+='<span class="font-icon btn-icon"></span>';
								str+='</div>';
								var qtl = currQue.queText[0].text.length;
									str+='<div class="btn-txt display-cell">'
									for(var r=0; r<qtl; r++){
										var _style = currQue.queText[0].text[r].style || "";
										var _className = currQue.queText[0].text[r].className || "";
										str+= '<p class ="txt '+_className+'" style="'+_style+'">'+currQue.queText[0].text[r].Text+'</p>';
									 }
									str+= '</div>';
								str+= '</a></div>';
							}
							if(mode == 'static' || mode == 'editable'){
								
								str+= '<div class="question"><div class="display-table que">';
									str+= '<div class="display-cell num">';
										var num = APP.globalXmlsObj.screenDataXML.numbers[0].number[(static_count+1)];
										if(num == null || num == undefined){
											num = (static_count+1);
										}else{
											num = num.Text;
										}
										str+= '<span class="num-txt">'+num+'</span>';
									str+= '</div>';

									str+= '<div class="display-cell que-txt">';
										var qtl = currQue.queText[0].text.length;
										for(var r=0; r<qtl; r++){
											var _style = currQue.queText[0].text[r].style || "";
											var _className = currQue.queText[0].text[r].className || "";
											str+= '<p class ="txt '+_className+'" style="'+_style+'">'+num+'. '+currQue.queText[0].text[r].Text+'</p>'; //YSHERE
										 }
									str+= '</div>';
								str+= '</div>';
							}
							if(mode == 'static' || mode == 'editable'){
								str+='<div class="notes-panel">'	
									str+='<div class="notes-txt"><p>'+APP.globalXmlsObj.screenDataXML.commonText[0].notesTxt[0].Text+'</p></div>';
									if(mode == 'static'){
										str+='<div class="notes-input"></div>';	
									}
									if(mode == 'editable'){
										str+='<div class="notes-input">'
											str+='<textarea class="text-area input-box" maxlength="150" ></textarea>';
										str+='</div>';
									}
								str+='</div>'
								str+='<div class="score-panel">'
									str+='<div class="score-txt"><p>'+APP.globalXmlsObj.screenDataXML.commonText[0].scoreTxt[0].Text+'</p></div>';
									if(mode == 'static'){
										str+='<div class="score-input"></div>';	
									}
									if(mode == 'editable'){								
										/* str+='<div class="score-input">'
											str+='<input class="text-area input-box" maxlength="10" ></input>';
										str+='</div>'; */
										//--dropdown
										str+=_this.getScoreDropDown();	
									}								
								str+='</div>';
								str+='</div>';
							}
							static_count++;
						}
				/* 3 */str+='</div>';
				if(mode == '' || mode == 'normal' || mode == 'selectable'){
					str+='<div class="line-spacer"><span/></div>';
				}
			/* 2 */str+='</div>'
			}
	}
	/* 1 */str+='</div>';
	return str;
	}
	_this.selectedTypedSkillQuestions = function(_obj){
		var str = '';
		var typedObj = APP.interviewQuesObj.typedSkill;
		if(typedObj==null || typedObj.length == 0){
			return '';
		}
		
		var isQueAvl=false;
		for(var i=0; i<typedObj.length; i++){
			if(typedObj[i].title != ''){
				var curr = typedObj[i].addedQ;
				if(curr.length){
					for(var j=0; j<curr.length; j++){
						if(curr[j].txt != null && curr[j].txt != ''){
							isQueAvl = true;
						}
					}
				}
			}
		}
		if(!isQueAvl){			
			return '';
		}
		var className ='';
		var mode ='normal';
		if(_obj){
			if(_obj.className){
				className = _obj.className; 
			}			
			if(_obj.mode){
				mode = _obj.mode; 
			}
		}
		/* 1 */str+='<div class=" cust-skill-ques static-typed-questions '+className+' mode_'+mode+'">';
		
		var static_count = 0;
		for(var i=0; i<typedObj.length; i++){
			if(typedObj[i].title==null || typedObj[i].title == ''){
				continue;
			}
			str+='<div class="head">';
				if(mode == 'editable'){
					str+='<div class="panel-title"><span>'+typedObj[i].title+'</span><span class ="score-details"></span></div>';					
				}else{
					str+='<div class="panel-title">'+typedObj[i].title+'</div>';
				}				
				str+='<p class="sub-title">'+APP.globalXmlsObj.screenDataXML.skillQuestionScreen[0].placeholderQuestion[0].subHeading[0].Text+'</p>';
				
			str+='</div>';
			
			var curr = typedObj[i].addedQ;
			if(curr.length){
				for(var q=0; q<curr.length; q++){				
					if(curr[q].txt == null || curr[q].txt == ''){
						continue;
					}				
					if(mode == 'static' || mode == 'editable'){
						str+= '<div class="question"><div class="display-table que">';
							str+= '<div class="display-cell num">';
								var num = APP.globalXmlsObj.screenDataXML.numbers[0].number[(static_count+1)];
								if(num == null || num == undefined){
									num = (static_count+1);
								}else{
									num = num.Text;
								}
								str+= '<span class="num-txt">'+num+'</span>';
							str+= '</div>';
							str+= '<div class="display-cell que-txt">';						
								str+= '<p class ="txt " >'+curr[q].txt+'</p>';						 
							str+= '</div>';
						str+= '</div>';
					}
					if(mode == 'static' || mode == 'editable'){
						str+='<div class="notes-panel">'	
							str+='<div class="notes-txt"><p>'+APP.globalXmlsObj.screenDataXML.commonText[0].notesTxt[0].Text+'</p></div>';
							if(mode == 'static'){
								str+='<div class="notes-input"></div>';	
							}
							if(mode == 'editable'){
								str+='<div class="notes-input">'
									str+='<textarea class="text-area input-box" maxlength="150"></textarea>';
								str+='</div>';
							}
						str+='</div>'
						str+='<div class="score-panel">'
							str+='<div class="score-txt"><p>'+APP.globalXmlsObj.screenDataXML.commonText[0].scoreTxt[0].Text+'</p></div>';
							if(mode == 'static'){
								str+='<div class="score-input"></div>';	
							}
							if(mode == 'editable'){								
								/* str+='<div class="score-input">'
									str+='<input class="text-area input-box" maxlength="10" ></input>';
								str+='</div>'; */
								//--dropdown
								str+=_this.getScoreDropDown();	
							}								
						str+='</div>';
						str+='</div>';
					}
				static_count++;
				}
			}
		}
		/* 1 */str+='</div>';
		return str;
	}
	_this.selectedTypedQuestions = function(_obj){
		var str = '';
		var typedObj = APP.interviewQuesObj.typedQues;
		if(typedObj==null || typedObj.length == 0){
			return '';
		}
		var blankCount=0;
		for(var i=0; i<typedObj.length; i++){
			if(typedObj[i].txt == ''){
				blankCount++;
			}
		}
		if(blankCount >= typedObj.length){			
			return '';
		}
		var className ='';
		var mode ='normal';
		if(_obj){
			if(_obj.className){
				className = _obj.className; 
			}			
			if(_obj.mode){
				mode = _obj.mode; 
			}
		}
		/* 1 */str+='<div class="static-typed-questions '+className+' mode_'+mode+'">';
		
		var static_count = 0;
		for(var q=0; q<typedObj.length; q++){	
			if(typedObj[q].txt == ''){
				continue;
			}
			if(mode == 'static' || mode == 'editable'){
				str+= '<div class="question"><div class="display-table que">';
					str+= '<div class="display-cell num">';
						var num = APP.globalXmlsObj.screenDataXML.numbers[0].number[(static_count+1)];
						if(num == null || num == undefined){
							num = (static_count+1);
						}else{
							num = num.Text;
						}
						str+= '<span class="num-txt">'+num+'</span>';
					str+= '</div>';
					str+= '<div class="display-cell que-txt">';						
						str+= '<p class ="txt " >'+num+'. '+typedObj[q].txt+'</p>';						 
					str+= '</div>';
				str+= '</div>';
			}
			if(mode == 'static' || mode == 'editable'){
				str+='<div class="notes-panel">'	
					str+='<div class="notes-txt"><p>'+APP.globalXmlsObj.screenDataXML.commonText[0].notesTxt[0].Text+'</p></div>';
					if(mode == 'static'){
						str+='<div class="notes-input"></div>';	
					}
					if(mode == 'editable'){
						str+='<div class="notes-input">'
							str+='<textarea class="text-area input-box" maxlength="150"></textarea>';
						str+='</div>';
					}
				str+='</div>'
				str+='<div class="score-panel">'
					str+='<div class="score-txt"><p>'+APP.globalXmlsObj.screenDataXML.commonText[0].scoreTxt[0].Text+'</p></div>';
					if(mode == 'static'){
						str+='<div class="score-input"></div>';	
					}
					if(mode == 'editable'){								
						/* str+='<div class="score-input">'
							str+='<input class="text-area input-box" maxlength="10" ></input>';
						str+='</div>'; */
						//--dropdown
							str+=_this.getScoreDropDown();	
					}								
				str+='</div>';
				str+='</div>';
			}
			static_count++;
		}
		/* 1 */str+='</div>';
		return str;
	}
	_this.selectedGeneralQuestions = function(_obj){
		var str = '';
		var genObj = APP.interviewQuesObj.generalQues;		
		var allQueObj = APP.globalXmlsObj.globalXML.generalQuestions[0].question; 
		var className ='';
		var mode ='normal';
		if(_obj){
			if(_obj.className){
				className = _obj.className; 
			}			
			if(_obj.mode){
				mode = _obj.mode; 
			}
		}
		//--for skipping unselected question 
		if(mode == 'static' || mode == 'editable'){
			if(genObj==null || genObj.length == 0){
				return '';
			}
			var blankCount=0;
			for(var i=0; i<genObj.length; i++){
				if(genObj[i].pick == false){
					blankCount++;
				}
			}
			if(blankCount >= genObj.length){			
				return '';
			}
		}
		/* 1 */str+='<div class="questions '+className+' mode_'+mode+'">';
			var static_count = 0;
			var Qlen = allQueObj.length;
			for(var k=0; k<Qlen; k++){
				if(mode == '' || mode == 'normal' || mode == 'selectable'){
				  if(genObj.length < Qlen){
					  if(k==0){
						 genObj = []; 
					  }
					  var temp = {
						  id:k,
						  pick:false					  
					  }
					  APP.interviewQuesObj.generalQues.push(temp);
				  }					  
				  }else{
					if(genObj[k].pick == false){
						continue;
					}
				}
				var currQue =  allQueObj[k];			
				var _style = currQue.style || "";
				var _className = currQue.className || "";
				
				if(mode == '' || mode == 'normal' || mode == 'selectable'){
					str+= '<div class="btn-panel"><a class="btn choice-btn click-item '+_className+' choice-btn_'+k+'" href="javascript:void(0);" data-id="'+k+'" style="'+_style+'">';
					str+='<div class="btn-icon-div display-cell">';
						str+='<span class="font-icon btn-icon"></span>';
					str+='</div>';
					var qtl = currQue.queText[0].text.length;
						str+='<div class="btn-txt display-cell">'
						for(var r=0; r<qtl; r++){
							var _style = currQue.queText[0].text[r].style || "";
							var _className = currQue.queText[0].text[r].className || "";
							str+= '<p class ="txt '+_className+'" style="'+_style+'">'+currQue.queText[0].text[r].Text+'</p>';
						 }
						str+= '</div>';
					str+= '</a></div>';
				}
				if(mode == 'static' || mode == 'editable'){
					str+= '<div class="question"><div class="display-table que">';
						str+= '<div class="display-cell num">';
							var num = APP.globalXmlsObj.screenDataXML.numbers[0].number[(static_count+1)];
							if(num == null || num == undefined){
								num = (static_count+1);
							}else{
								num = num.Text;
							}
							str+= '<span class="num-txt">'+num+'</span>';
						str+= '</div>';
						str+= '<div class="display-cell que-txt">';
							var qtl = currQue.queText[0].text.length;
							for(var r=0; r<qtl; r++){
								var _style = currQue.queText[0].text[r].style || "";
								var _className = currQue.queText[0].text[r].className || "";
								str+= '<p class ="txt '+_className+'" style="'+_style+'">'+num+'. '+currQue.queText[0].text[r].Text+'</p>';
							 }
						str+= '</div>';
					str+= '</div>';
				}
				if(mode == 'static' || mode == 'editable'){
					str+='<div class="notes-panel">'	
						str+='<div class="notes-txt"><p>'+APP.globalXmlsObj.screenDataXML.commonText[0].notesTxt[0].Text+'</p></div>';
						if(mode == 'static'){
							str+='<div class="notes-input"></div>';	
						}
						if(mode == 'editable'){
							str+='<div class="notes-input">'
								str+='<textarea class="text-area input-box" maxlength="150" ></textarea>';
							str+='</div>';
						}
					str+='</div>'
					str+='<div class="score-panel">'
						str+='<div class="score-txt"><p>'+APP.globalXmlsObj.screenDataXML.commonText[0].scoreTxt[0].Text+'</p></div>';
						if(mode == 'static'){
							str+='<div class="score-input"></div>';	
						}
						if(mode == 'editable'){								
							/* str+='<div class="score-input">'
								str+='<input class="text-area input-box" maxlength="10"></input>';
							str+='</div>'; */
							//--dropdown
							str+=_this.getScoreDropDown();	
							
						}								
					str+='</div>';
					str+='</div>';
				}
				static_count++;
			  }	
		  /* 1 */str+='</div>';
		return str;
	}
	_this.getScoreDropDown=function(_onlyPoint){
		var scoreTableObj = APP.globalXmlsObj.screenDataXML.scoreTable;
		var scoreObj = scoreTableObj[0].scores[0].score;
		var defaultTxtObj = scoreTableObj[0].defaultTxt[0];			
		str='';
		str+='<div class="dropDown">';	
			str += '<div class="ui-front dd-menu-panel">';
				str+='<div class="drop-down-panel">';	
					str += '<select class="drop-down" >';
						str += '<option value="'+defaultTxtObj.value+'" selected="selected">'+defaultTxtObj.Text+'</option>';
						for(var i=0; i<scoreObj.length; i++){
							var _value = scoreObj[i].value;
							if(_onlyPoint){
								var _txt= scoreObj[i].point[0].Text;
							}else{
								var _txt= scoreObj[i].point[0].Text +' - '+scoreObj[i].description[0].Text;
							}
							str += '<option value="'+_value+'">'+_txt+'</option>';
						}						
					str += '</select>';
				str+='</div>';												
			str+='</div>';	
		str+='</div>';
		return str;
	}
}