function AddInfoScreen() {
	var _this = this;
	var Selector = {};
	_this.start = function (_obj) {
		Selector = {
			ACTIVITY_PANEL: '.add-info-screen',
			SELECTED_CLASS: 'selected',
			ACTIVE_ITEM_CLASS: 'active',
			ITEM: '.input-box',						
			ON_CHANGE: null,
			ON_COMPLETE: null,
			maxLength:350
		};
		Selector = $.extend(Selector, _obj);
		initTemplate();
	}
	_this.start();
	
	function initTemplate() {
		
		Selector.xmlNode = APP.globalXmlsObj.screenDataXML.additionalInfoScreen[0];		
		
		Selector.isCompleted = false;
		
		/* 1 */var str = '<div class="page add-info-screen " >';
		/* 2 */str += '<div class="page-panel no-padding-top clearfix">';
		str+='<div class="pdf-btns-panel">'
			//-- Question guidance button
			 var returned = APP.GetHtmlStructObj.getCommonBtn({
				className:'que-guide',
				btnObj:APP.globalXmlsObj.screenDataXML.commonText[0].queGuideBtn 
			}); 
			if(returned !=''){
				str+=returned;
			}
			
		str+='</div>'
		 if(Selector.xmlNode.title){
			 var _style = Selector.xmlNode.title[0].style || "";
			 var _className = Selector.xmlNode.title[0].className || "";
			 str+= '<p class ="page-title '+_className+'" style="'+_style+'">'+Selector.xmlNode.title[0].Text+'</p>';
		 }
		 if(Selector.xmlNode.ostText){
			 var len = Selector.xmlNode.ostText[0].text.length;
			 /* 2a */str+='<div class="ost-panel">'
			 for(var i=0; i<len; i++){
				var _style = Selector.xmlNode.ostText[0].text[i].style || "";
				var _className = Selector.xmlNode.ostText[0].text[i].className || "";
				str+= '<p class ="txt '+_className+'" style="'+_style+'">'+Selector.xmlNode.ostText[0].text[i].Text+'</p>';
			 }
			  /* 2a */str+='</div>';
		 }
		 //-- input box
		 var intxt ='';
		 if(APP.interviewQuesObj.additionalInfo){
			intxt= APP.interviewQuesObj.additionalInfo.txt || ''; 
		 }
		 str+='<div class="input-panel">'; 
				str+='<textarea class="text-area input-box" data-id="0" data-currlength="0">'+intxt+'</textarea>'; 
				str+='<span class="placeholder-txt">'+Selector.xmlNode.queText[0].Text+'</span>';				
				str+='<div class="indicator-panel"><i><span class="wd-left-length"></span> '+Selector.xmlNode.charLeft[0].Text+'</i></div>';
			str+='</div>';
		  	 
			//-- download data button
		 	var returned0 = APP.GetHtmlStructObj.getCommonBtn({
				className:'margin-top pull-left download-data-btn',
				btnObj:APP.globalXmlsObj.screenDataXML.commonText[0].downloadDataFileBtn 
			}); 
			if(returned0 !=''){
				str+=returned0;
			}
			//-- download doc button
			var returned0 = APP.GetHtmlStructObj.getCommonBtn({
				className:'margin-top pull-left margin-left download-doc-btn',
				btnObj:APP.globalXmlsObj.screenDataXML.commonText[0].downloadDocBtn 
			}); 
			if(returned0 !=''){
				str+=returned0;
			}

			//-- generate button
			var returned = APP.GetHtmlStructObj.getCommonBtn({
				className:'margin-top pull-right access-screen',
				btnObj:APP.globalXmlsObj.screenDataXML.commonText[0].finalBtn 
			}); 
			if(returned !=''){
				str+=returned;
			}
			/* 2 */str+='</div>';
		/* 1 */str+='</div>';
		$('#page-container').html(str);
		$(document).trigger(APP.eventObj.ON_PAGE_LOADCOMPLETE);
		
		validateInput();
		updateTemplateLayout();
		addTemplateEvent();
		updateStatus();
		
	}
	function validateInput(){
		$(Selector.ACTIVITY_PANEL).find(Selector.ITEM).attr('maxlength',Selector.maxLength);
		Selector.totalItem = $(Selector.ACTIVITY_PANEL).find('.text-area').length;
		$(Selector.ACTIVITY_PANEL).find(Selector.ITEM).each(function (inx){
			var val= $.trim($(this).val());
			var len = $(this).val().length;			
			$(this).data('currlength', len);
			
			if(val == ''){
				$(this).siblings('.placeholder-txt').show();	
			}else{
				$(this).siblings('.placeholder-txt').hide();	
			}
			
			var $txtElm = $(this).siblings('.indicator-panel');
			pg_updateLeftChar($txtElm, len);
		})
		
	}
	function addTemplateEvent() {
		$('#app-body').on('click', '.add-info-screen .placeholder-txt', function (e) {
			$(this).hide();
			$(this).siblings('.input-box').focus();
		});
		$('#app-body').on('focus', '.add-info-screen .input-box', function (e) {
			
			$(this).siblings('.placeholder-txt').hide();	
			
		});
		
		var evt="keydown keyup blur";
		if(APP.systemDetectorObj.browserName == 'ie'){
			evt= "keypress keyup blur"
		}
		
		$('#app-body').on(evt, '.add-info-screen .input-box', function (event) {
			var val= $.trim($(this).val());
			//console.log(val);
			var id = $(this).data('id');			
			var len = $(this).val().length;			
			$(this).data('currlength', len);
			var $txtElm = $(this).siblings('.indicator-panel');
			if(val == ''){
				$(this).siblings('.placeholder-txt').show();	
			}else{
				$(this).siblings('.placeholder-txt').hide();	
			}
			pg_updateLeftChar($txtElm, len);
			if (Selector.ON_CHANGE) {
				Selector.ON_CHANGE(id);
			}
			checkInterviewQuesObj();
			updateStatus();
		});
		
	}
	
	function pg_updateLeftChar(_el,_curr){
		var leftLength = Selector.maxLength - _curr;
		$(_el).find('.wd-left-length').html(leftLength);
	}
	
	function updateStatus() {		
		Selector.isCompleted = true;		
		if (Selector.isCompleted) {
			pageCompleted();
		}
		
	}
	function checkInterviewQuesObj(){		
		var $obj = $(Selector.ACTIVITY_PANEL).find(Selector.ITEM);	
		//console.log('$obj: '+$obj.length)
		APP.interviewQuesObj.additionalInfo={};
		$obj.each(function (idx) {
			//console.log('00idx: '+idx);
			var id = $(this).data('id');
			var txt= $.trim($(this).val());			
			APP.interviewQuesObj.additionalInfo={txt: txt}			
		})
		$(document).trigger(APP.eventObj.ON_PAGE_UPDATE);
	}
	function updateTemplateLayout() {
		
	}
	$(document).bind(APP.eventObj.ON_SCREEN_RESIZE, function (e) {
		updateTemplateLayout();
	});

	
	function pageCompleted() {
		if (Selector.ON_COMPLETE) {
			Selector.ON_COMPLETE();
		}
		APP.courseDataObj.updatePageCompletion(2);
	}
}