function SkillQuestions() {
	var _this = this;
	var Selector = {};
	_this.start = function (_obj) {
		Selector = {
			ACTIVITY_PANEL: '.skill-question-screen',
			SELECTED_CLASS: 'selected',
			ACTIVE_ITEM_CLASS: 'active',
			ITEM: '.click-item',						
			ON_CHANGE: null,
			ON_COMPLETE: null,
			appendDiv:'#page-container',
			isSeparatePage:true
		};
		Selector = $.extend(Selector, _obj);
		initTemplate();
	}
	//_this.start();
	
	function initTemplate() {
		
		Selector.xmlNode = APP.globalXmlsObj.screenDataXML.skillQuestionScreen[0];		
		Selector.icon={
			normal:APP.globalXmlsObj.screenDataXML.commonText[0].questionsBtn[0].normalIcon[0].Text,
			selected:APP.globalXmlsObj.screenDataXML.commonText[0].questionsBtn[0].selectedIcon[0].Text
		}
		Selector.isCompleted = false;
		
		/* 1 */var str = '<div class="page skill-question-screen " >';
		/* 2 */str += '<div class="page-panel no-padding-top clearfix">';
		if(Selector.isSeparatePage){
			 if(Selector.xmlNode.title){
				 var _style = Selector.xmlNode.title[0].style || "";
				 var _className = Selector.xmlNode.title[0].className || "";
				 str+= '<p class ="page-title '+_className+'" style="'+_style+'">'+Selector.xmlNode.title[0].Text+'</p>';
			 }
		}
		 if(Selector.xmlNode.ostText){
			 var len = Selector.xmlNode.ostText[0].text.length;
			 /* 2a */str+='<div class="ost-panel">'
			 for(var i=0; i<len; i++){
				var _style = Selector.xmlNode.ostText[0].text[i].style || "";
				var _className = Selector.xmlNode.ostText[0].text[i].className || "";
				str+= '<p class ="txt '+_className+'" style="'+_style+'">'+Selector.xmlNode.ostText[0].text[i].Text+'</p>';
			 }
			  /* 2a */str+='</div>';
		 }
		 
		 //-- skill		 
		 str+= APP.GetHtmlStructObj.selectedSkillQuestions({			 
				mode:'selectable'
			}); 
		 //--
		 //--for typed skill question-screen
		if(APP.interviewQuesObj.typedSkill[0].title != null && APP.interviewQuesObj.typedSkill[0].title!=''){
			str+='<div id="cust-skill-que-container" class="cust-skill-que-container"></div>';
			str+='<div class="line-spacer"><span/></div>';
		}
		 
		 //--
		 //-- next step
		 var returned = APP.GetHtmlStructObj.getCommonBtn({
				className:'margin-top pull-right btn-next-step',
				btnObj:APP.globalXmlsObj.screenDataXML.commonText[0].nextStepBtn 
			}); 
			if(returned !=''){
				str+=returned;
			}
			
			/* 2 */str+='</div>';
		/* 1 */str+='</div>';
		$(Selector.appendDiv).html(str);
		generateCustSkillQuestions();
		if(Selector.isSeparatePage){
			$(document).trigger(APP.eventObj.ON_PAGE_LOADCOMPLETE);
		}
		Selector.totalItem = $(Selector.ACTIVITY_PANEL).find('.choice-btn').length;
		setPreviousData();
		updateTemplateLayout();
		addTemplateEvent();
		updateStatus();
		
	}
	function generateCustSkillQuestions(){
		var qs = new CustomSkillQuestions();
		qs.start({
			appendDiv: '#cust-skill-que-container',
			dataObj:APP.interviewQuesObj.typedSkill[0],
			isSeparatePage:false,
			defaultQues:1,
		});
	}
	function setPreviousData(){
		var skillObj= APP.interviewQuesObj.selectedSkill;
		
		var selectedCount = 0;
		if(skillObj.length){
			for(var i=0; i<skillObj.length; i++){
				for(var j=0; j<skillObj[i].length; j++){
					if(skillObj[i][j].pick == false){
						continue;
					}
					selectedCount++;
					var curr = skillObj[i][j].pickQ;
					if(curr){				
						if(curr.length){
							for(var k=0; k<curr.length; k++){
								var sel = '.choice-btn_'+skillObj[i][j].groupId+'_'+skillObj[i][j].id+'_'+curr[k].id;
								if(curr[k].pick==true){		
									
									$(Selector.ACTIVITY_PANEL).find(sel).addClass(Selector.SELECTED_CLASS);
									$(Selector.ACTIVITY_PANEL).find(sel).find('.btn-icon').html(Selector.icon.selected);
								}else{
									$(Selector.ACTIVITY_PANEL).find(sel).find('.btn-icon').html(Selector.icon.normal);
								}
							}
						}	
					}				
				}
			}
		}
		if(selectedCount <= 0){
			$(Selector.ACTIVITY_PANEL).find('.ost-panel').remove();
		}
	}
	function addTemplateEvent() {
		$(Selector.ACTIVITY_PANEL).find(Selector.ITEM).on('click', function () {
			if ($(this).hasClass('disabled')) {return false;}
			var groupid = $(this).data('groupid');
			var id = $(this).data('id');
			var subId = $(this).data('subid');
			//console.log('id: '+id);
			//console.log('subId: '+subId);
			selectItem(groupid, id, subId);
		});
		$(Selector.ACTIVITY_PANEL).find('.select-all-btn').on('click', function () {
			if ($(this).hasClass('disabled')) {return false;}
			var $obj = $(this).parent().siblings('.questions');
			selectDeselectAll($obj);
		});
	}

	function selectItem(_groupid, _id, _subId) {
		//console.log('select _groupid: '+_groupid);
		//console.log('select _id: '+_id);
		//console.log('select _subId: '+_subId);
		var sel = '.choice-btn_'+_groupid+'_'+_id+'_'+_subId;
		var $curr = $(Selector.ACTIVITY_PANEL).find(sel);
		if($curr.hasClass(Selector.SELECTED_CLASS)){
			$curr.removeClass(Selector.SELECTED_CLASS);
			$curr.find('.btn-icon').html(Selector.icon.normal);
		}else{
			$curr.addClass(Selector.SELECTED_CLASS);
			$curr.find('.btn-icon').html(Selector.icon.selected);
		}
		if (Selector.ON_CHANGE) {
			Selector.ON_CHANGE(_groupid, _id, _subId);
		}
		checkInterviewQuesObj();
		updateStatus();
	}
	function selectDeselectAll($obj){
		var $chObj = $obj.find('.choice-btn');
		var $selected = $obj.find('.choice-btn.'+Selector.SELECTED_CLASS);
		if($selected.length >= $chObj.length){
			//do deselect all
			$chObj.each(function (idx) {
				$(this).removeClass(Selector.SELECTED_CLASS);
				$(this).find('.btn-icon').html(Selector.icon.normal);
				
				if (Selector.ON_CHANGE) {
					Selector.ON_CHANGE(idx);
				}
			});
		}else{
			//do select all
			$chObj.each(function (idx) {
				$(this).addClass(Selector.SELECTED_CLASS);
				$(this).find('.btn-icon').html(Selector.icon.selected);
				if (Selector.ON_CHANGE) {
					Selector.ON_CHANGE(idx);
				}
			});
		}
		checkInterviewQuesObj();
		updateStatus();
	}
	function updateStatus() {
		var visitedCount = $(Selector.ACTIVITY_PANEL).find('.choice-btn.'+Selector.SELECTED_CLASS).length;
		if (visitedCount >= 1) {
			Selector.isCompleted = true;
		} else {
			Selector.isCompleted = false;
		}
		if (Selector.isCompleted) {
			pageCompleted();
		}
		
	}
	function checkInterviewQuesObj(){
		
		var $obj = $(Selector.ACTIVITY_PANEL).find('.skill-panel');
		
		$obj.each(function (idx) {
			var groupid = $(this).data('groupid');
			var id = $(this).data('id');
			//get correct id from stored object
			var accGroupId = null;
			var accId = null;
			for(var i=0; i<APP.interviewQuesObj.selectedSkill.length; i++){
				for(var j=0; j<APP.interviewQuesObj.selectedSkill[i].length; j++){
					if(APP.interviewQuesObj.selectedSkill[i][j].groupId == groupid){
						accGroupId = i;						
					}
					if(APP.interviewQuesObj.selectedSkill[i][j].id == id){
						accId = j;						
					}
				}
			}
			var $selectedObj = $(this).find('.choice-btn.'+Selector.SELECTED_CLASS);
			$selectedObj.each(function (idx) {
				//console.log('111idx: '+idx);
				var sunId = $(this).data('subid');				
				if(accGroupId != null && accId != null){
					APP.interviewQuesObj.selectedSkill[accGroupId][accId].pickQ[sunId].pick = true;
				}
			})
			var $normalObj = $(this).find('.choice-btn:not(.'+Selector.SELECTED_CLASS+')');
			$normalObj.each(function (idx) {
				//console.log('111idx: '+idx);
				var sunId = $(this).data('subid');				
				if(accGroupId != null && accId != null){
					APP.interviewQuesObj.selectedSkill[accGroupId][accId].pickQ[sunId].pick = false;
				}
			})
		})
		$(document).trigger(APP.eventObj.ON_PAGE_UPDATE);
	}
	function updateTemplateLayout() {
		
	}
	$(document).bind(APP.eventObj.ON_SCREEN_RESIZE, function (e) {
		updateTemplateLayout();
	});

	
	function pageCompleted() {
		if (Selector.ON_COMPLETE) {
			Selector.ON_COMPLETE();
		}
		if(Selector.isSeparatePage){
			APP.courseDataObj.updatePageCompletion(2);
		}
	}
}