function SkillSelection() {
	var _this = this;
	var Selector = {};
	_this.start = function (_obj) {
		Selector = {
			ACTIVITY_PANEL: '.skill-selection-screen',
			SELECTED_CLASS: 'selected',
			ACTIVE_ITEM_CLASS: 'active',
			ITEM: '.click-item',						
			ON_CHANGE: null,
			ON_COMPLETE: null
		};
		Selector = $.extend(Selector, _obj);
		initTemplate();
	}
	_this.start();
	
	function initTemplate() {
		Selector.skillXmlNode = APP.globalXmlsObj.globalXML.skills[0];	
		Selector.xmlNode = APP.globalXmlsObj.screenDataXML.skillSelectionScreen[0];	
		Selector.icon={
			normal:APP.globalXmlsObj.screenDataXML.commonText[0].accordionBtn[0].normalIcon[0].Text,
			selected:APP.globalXmlsObj.screenDataXML.commonText[0].accordionBtn[0].selectedIcon[0].Text
		}		
		Selector.isCompleted = false;
		
		/* 1 */var str = '<div class="page skill-selection-screen " >';
			str +='<div class="modal fade generic" id="skill-desc-modal" role="dialog">';
				str +='<div class="modal-dialog">';		
					  str +='<div class="modal-content">';
						str +='<div class="modal-header">';						  
						  str +='<div class="modal-title">Modal Header</div>';
						str +='</div>';
						str +='<div class="modal-body">';
						  str +='<p>Some text in the modal.</p>';
						str +='</div>';						
					  str +='</div>';		  
				str +='</div>';
			str +='</div>';
		/* 2 */str += '<div class="page-panel">';
		 if(Selector.xmlNode.ostText){
			 var len = Selector.xmlNode.ostText[0].text.length;
			 /* 2a */str+='<div class="ost-panel">'
			 for(var i=0; i<len; i++){
				var _style = Selector.xmlNode.ostText[0].text[i].style || "";
				var _className = Selector.xmlNode.ostText[0].text[i].className || "";
				str+= '<p class ="txt '+_className+'" style="'+_style+'">'+Selector.xmlNode.ostText[0].text[i].Text+'</p>';
			 }
			  /* 2a */str+='</div>';
		 }
		var isPrevSelected = isAnyPicked();
		/* 2a */str += '<div class="panel-group margin-top" role="tablist" aria-multiselectable="true">';
			/* 2b */str += '<div class="panel panel-default">';
				/* 2c */str += '<div class="btn-panel accordion-btn-panel" role="tab" id="skill-heading01">';
				
					str += '<a class="btn accordion-btn collapsed display-table" data-toggle="collapse" data-parent="#skill-accordion" href="#skill-collapse01" aria-expanded="'+!isPrevSelected+'" aria-controls="skill-collapse01"><span class="btn-txt display-cell">';
					if(Selector.xmlNode.title){
						 var _style = Selector.xmlNode.title[0].style || "";
						 var _className = Selector.xmlNode.title[0].className || "";
						 str+= '<p class ="txt '+_className+'" style="'+_style+'">'+Selector.xmlNode.title[0].Text+'</p>';
					 }
					 var tickIcon = Selector.icon.selected;
					 if(isPrevSelected){
						 tickIcon = Selector.icon.normal;
					 }
					str+= '</span><span class="btn-icon font-icon display-cell">'+tickIcon+'</span></a>';
				/* 2c */str += '</div>';
				if(isPrevSelected){
					/* 2d */str += '<div id="skill-collapse01" class="panel-collapse collapse" role="tabpanel" aria-labelledby="skill-heading01">';
				}else{
					/* 2d */str += '<div id="skill-collapse01" class="panel-collapse collapse in" role="tabpanel" aria-labelledby="skill-heading01">';
				}
				/* 2e */str += '<div class="panel-body">';
				
		 //-- selectAllbutton
		 var returned = APP.GetHtmlStructObj.getCommonBtn({
				className:'select-all-btn',
				btnObj:APP.globalXmlsObj.screenDataXML.commonText[0].selectAllBtn
			}); 
			if(returned !=''){
				str+=returned;
			}
		 //--group
		 var grLen = Selector.skillXmlNode.group.length;
		 for(var j=0; j<grLen; j++){
				var _class = "group_"+(j);
				if(APP.interviewQuesObj.selectedSkill.length < grLen){
					if(j==0){
						APP.interviewQuesObj.selectedSkill = []; 
					  }
					  var temp = []
					  APP.interviewQuesObj.selectedSkill.push(temp);
				}
			  /* 3a0 */str+='<div class="group-panel margin-top '+_class+'">'
				str+='<p class="group-title">'+Selector.skillXmlNode.group[j].title[0].Text+'</p>'
		 //-- skill
		  /* 3 */str+='<div class="skills-panel margin-top">'
		  var len = Selector.skillXmlNode.group[j].skill.length;
		  //console.log('len: '+len)
		  //Selector.totalItem = len;
		  for(var k=0; k<len; k++){
			  //--only create first time
			  if(APP.interviewQuesObj.selectedSkill[j].length < len){
				  if(k==0){
					 APP.interviewQuesObj.selectedSkill[j] = []; 
				  }
				  var temp = {
					  groupId:j,
					  id:k,
					  pick:false,
					  pickQ:[],
					  rolesArr:[]					  
				  }
				  APP.interviewQuesObj.selectedSkill[j].push(temp);
			  }
			
			  //console.log('k: '+k)
			var skill = Selector.skillXmlNode.group[j].skill[k];
			//--add roles arr
			if(skill.roles){
				APP.interviewQuesObj.selectedSkill[j][k].rolesArr=skill.roles.split(',');
			}
			
			
			//--
			var _style = skill.style || "";
			var _className = skill.className || "";
			/* 3aa */str+='<div class="btn-div">'
			/* 3a */str+='<a class="skill-panel btn choice-btn click-item skill-panel_'+j+'-'+k+' '+_className+'" style="'+_style+'" data-groupid="'+j+'" data-id="'+k+'"  href="javascript:void(0);">'
			str+='<div class="head">'
			if(skill.icon){
				var _style = skill.icon[0].style || "";
				var _className = skill.icon[0].className || "";
				str+= '<span class ="font-icon icon '+_className+'" style="'+_style+'">'+skill.icon[0].Text+'</span>';
			}
			if(skill.title){
				var _style = skill.title[0].style || "";
				var _className = skill.title[0].className || "";
				str+= '<span class ="name '+_className+'" style="'+_style+'">'+skill.title[0].Text+'</span>';
			}
			
			
			str+='</div>';
			/* 3a */str+='</a>'
			str+= '<span class ="font-icon desc-icon" data-toggle="modal" data-target="#skill-desc-modal" data-groupid="'+j+'" data-uniid="'+k+'">&#xe919;</span>';
			/* 3aa */str+='</div>';
		  }
		  /* 3 */str+='</div>';
		  /* 3a0 */str+='</div>'
		 }
		  str+='<div id = "custom_skill-container" class="custom_skill-container margin-top"></div>';
		  
		 //--generate Questons
		 var returned = APP.GetHtmlStructObj.getCommonBtn({
				className:'margin-top pull-right generate-que-btn',
				btnObj:APP.globalXmlsObj.screenDataXML.commonText[0].generateQueBtn
			}); 
			if(returned !=''){
				str+=returned;
			}
		//--	
			/* 2e */str += '</div>';
			/* 2d */str += '</div>';
			/* 2b */str += '</div>';
			/* 2a */str += '</div>';
			/* 2 */str+='</div>';
		/* 1 */str+='</div>';
		
		str+='<div id = "ques-container"></div>';
		$('#page-container').html(str);
		generateCustomSkill();
		
		$(document).trigger(APP.eventObj.ON_PAGE_LOADCOMPLETE);
		setRoleData();
		setPreviousData();
		updateTemplateLayout();
		addTemplateEvent();
		updateStatus();
		
	}
	function setRoleData(){		
		if(APP.interviewQuesObj.selectedRole){
			if(APP.interviewQuesObj.selectedRole.role != null){
				for(var i=0; i<APP.interviewQuesObj.selectedSkill.length; i++){
					for(var j=0; j<APP.interviewQuesObj.selectedSkill[i].length; j++){
						var isAvl=false;
						var curr = APP.interviewQuesObj.selectedSkill[i][j];
						for(var m=0; m<curr.rolesArr.length; m++){
							var cr=curr.rolesArr[m];
							//console.log('selectedRole: '+APP.interviewQuesObj.selectedRole.role);
							//console.log('cr: '+cr);
							if(cr == APP.interviewQuesObj.selectedRole.role){
								isAvl=true;
								break;
							}
						}
						if(!isAvl){
							curr.pick= false;
							var _groupId = curr.groupId;
							var _id = curr.id;
							$(Selector.ACTIVITY_PANEL).find('.skill-panel_'+_groupId+'-'+_id).removeClass(Selector.SELECTED_CLASS).hide();							
							$(Selector.ACTIVITY_PANEL).find('.skill-panel_'+_groupId+'-'+_id).siblings('.desc-icon').hide();							
						}
					}
				}
			}
		}
	}
	function setPreviousData(){
		var isPrevSelected = false;
		if(APP.interviewQuesObj.selectedSkill.length){
			for(var i=0; i<APP.interviewQuesObj.selectedSkill.length; i++){
				for(var j=0; j<APP.interviewQuesObj.selectedSkill[i].length; j++){
					var curr = APP.interviewQuesObj.selectedSkill[i][j];
					if(curr.pick){
						var _groupId = curr.groupId;
						var _id = curr.id;
						$(Selector.ACTIVITY_PANEL).find('.skill-panel_'+_groupId+'-'+_id).addClass(Selector.SELECTED_CLASS);
						isPrevSelected = true;
					}
				}
			}
		}
		Selector.totalItem = $(Selector.ACTIVITY_PANEL).find('.skill-panel:visible').length;
		
		validateBtnStatus();
		if(isPrevSelected){
			$('.panel-collapse.in').collapse('hide');	
			$('#skill-heading01').find('.btn-icon').html(Selector.icon.normal);
			generateQuestions();
		}
	}
	function isAnyPicked(){
		var isPrevSelected = false;
		if(APP.interviewQuesObj.selectedSkill.length){
			for(var i=0; i<APP.interviewQuesObj.selectedSkill.length; i++){
				for(var j=0; j<APP.interviewQuesObj.selectedSkill[i].length; j++){
					var curr = APP.interviewQuesObj.selectedSkill[i][j];
					if(curr.pick){
						isPrevSelected = true;
						break;
					}
				}
			}			
		}
		return isPrevSelected;
	}
	function resetQuePanel(){
		$('#ques-container').html('');
	}
	function addTemplateEvent() {
		$(Selector.ACTIVITY_PANEL).find(Selector.ITEM).on('click', function () {
			if ($(this).hasClass('disabled')) {return false;}
			var _groupId = $(this).data('groupid');
			var _id = $(this).data('id');
			resetQuePanel();
			selectItem(_groupId, _id);
		});
		$(Selector.ACTIVITY_PANEL).find('.select-all-btn').on('click', function () {
			if ($(this).hasClass('disabled')) {return false;}
			selectDeselectAll();
		});
		$(Selector.ACTIVITY_PANEL).find('.generate-que-btn').on('click', function () {
			if ($(this).hasClass('disabled')) {return false;}
			$('#skill-collapse01').collapse('hide');
            $('#skill-heading01 .btn').attr('data-toggle', 'collapse');
            generateQuestions();			
			
		});
		//--for accordion minus icon
		$('.skill-selection-screen .panel-group').on('show.bs.collapse', function (e) {			
			var curr = '#'+e.target.id
			$(curr).siblings( ".accordion-btn-panel" ).find('.btn-icon').html(Selector.icon.selected);
			//APP.commonFunObj.scrollToElement($('#sections-panel'), false)
		})
		//--for accordion plus icon
		$('.skill-selection-screen .panel-group').on('hide.bs.collapse', function (e) {			
			var curr = '#'+e.target.id
			$(curr).siblings( ".accordion-btn-panel" ).find('.btn-icon').html(Selector.icon.normal);
			APP.commonFunObj.scrollToElement($('#sections-panel'), false)
		})
		
	//--
		/* $('.skill-selection-screen .desc-icon').on('click', function (event) {
			$('#skill-desc-modal').modal('show');
			 event.stopPropagation();
		}); */
		$('#skill-desc-modal').on('show.bs.modal', function (event) {
		  var button = $(event.relatedTarget);
		  var groupid = button.data('groupid');
		  var uniid = button.data('uniid');
		  var modal = $(this);
		  var currObj =Selector.skillXmlNode.group[groupid].skill[uniid];
		  var title = '<span class="font-icon skill-icon display-cell">'+currObj.icon[0].Text+'</span><span class="m-txt display-cell">'+currObj.title[0].Text+'</span><span class="display-cell close-cell"><button type="button" class="font-icon close" data-dismiss="modal">&#xe912;</button></span>';
		  modal.find('.modal-title').addClass('display-table').html(title);		  
		  modal.attr('data-groupref',(groupid));
			var str ='';
			var _style = currObj.description[0].style || "";
			var _className = currObj.description[0].className || "";
			str+= '<div class ="desc '+_className+'" style="'+_style+'">'
				var len1 = currObj.description[0].text.length;
				 str+='<div class="desc-panel">'
				 for(var j=0; j<len1; j++){
					var _style = currObj.description[0].text[j].style || "";
					var _className = currObj.description[0].text[j].className || "";
					str+= '<p class ="txt '+_className+'" style="'+_style+'">'+currObj.description[0].text[j].Text+'</p>';
				 }
				  str+='</div>';
			str+= '</div>';
			modal.find('.modal-body').html(str);
		})
	}
	function generateCustomSkill(){
		var qs = new CustomSkill();
		qs.start({
			appendDiv: '#custom_skill-container',
			isSeparatePage:false,
			ON_CHANGE:function(_id){
				resetQuePanel();
				validateBtnStatus();
			}
		});
	}
	function generateQuestions(){
		var qs = new SkillQuestions();
		qs.start({
			appendDiv: '#ques-container',
			isSeparatePage:false
		});
	}
	
	function selectItem(_groupId, _id) {
		//console.log('select: '+_id);
		var $curr = $(Selector.ACTIVITY_PANEL).find('.skill-panel_'+_groupId+'-'+_id);
		if($curr.hasClass(Selector.SELECTED_CLASS)){
			$curr.removeClass(Selector.SELECTED_CLASS);
		}else{
			$curr.addClass(Selector.SELECTED_CLASS);
		}
		if (Selector.ON_CHANGE) {
			Selector.ON_CHANGE(_groupId, _id);
		}
		checkInterviewQuesObj();
		validateBtnStatus();
		updateStatus();
	}
	function selectDeselectAll(){
		var $obj = $(Selector.ACTIVITY_PANEL).find('.skill-panel:visible');
		var $selected = $(Selector.ACTIVITY_PANEL).find('.skill-panel.'+Selector.SELECTED_CLASS);
		Selector.totalItem = $obj.length;
		//console.log('Selector.totalItem: '+Selector.totalItem)
		//console.log('$selected.length: '+$selected.length)

		if($selected.length >= Selector.totalItem){
			//do deselect all
			$obj.each(function (idx) {
				$(this).removeClass(Selector.SELECTED_CLASS);
				var groupId = $(this).data('groupid');
				var id = $(this).data('id');
				if (Selector.ON_CHANGE) {
					Selector.ON_CHANGE(groupId, id);
				}
			});
		}else{
			//do select all
			$obj.each(function (idx) {
				$(this).addClass(Selector.SELECTED_CLASS);
				var groupId = $(this).data('groupid');
				var id = $(this).data('id');
				if (Selector.ON_CHANGE) {
					Selector.ON_CHANGE(groupId, id);
				}
			});
		}
		resetQuePanel();
		checkInterviewQuesObj();
		validateBtnStatus();
		updateStatus();
	}
	function updateStatus() {
		Selector.isCompleted = true;
		var visitedCount = $(Selector.ACTIVITY_PANEL).find('.skill-panel.'+Selector.SELECTED_CLASS).length;
		if (visitedCount >= 1) {
			Selector.isCompleted = true;
		} else {
			Selector.isCompleted = false;
		}
		if (Selector.isCompleted) {
			pageCompleted();
		}
		
	}
	function checkInterviewQuesObj(){			
		var $selectedObj = $(Selector.ACTIVITY_PANEL).find('.skill-panel.'+Selector.SELECTED_CLASS);
		$selectedObj.each(function (idx) {
			if($selectedObj.is(":visible")){
				var groupId = $(this).data('groupid');
				var id = $(this).data('id');
				APP.interviewQuesObj.selectedSkill[groupId][id].pick = true;
			}
		});
		var $normalObj = $(Selector.ACTIVITY_PANEL).find('.skill-panel:not(.'+Selector.SELECTED_CLASS+')');
		$normalObj.each(function (idx) {
			var groupId = $(this).data('groupid');
			var id = $(this).data('id');
			APP.interviewQuesObj.selectedSkill[groupId][id].pick = false;			
		});
		$(document).trigger(APP.eventObj.ON_PAGE_UPDATE);
	}
	function validateBtnStatus(){
		var $selectedObj = $(Selector.ACTIVITY_PANEL).find('.skill-panel.'+Selector.SELECTED_CLASS);		
		var typedSkill = APP.interviewQuesObj.typedSkill;
		var isActive = false;
		
		if($selectedObj.length >= 1){
			isActive = true;
		}else if(typedSkill!= null){
			if(typedSkill[0].title != null && typedSkill[0].title != ''){
				isActive = true;				
			}else{
				isActive = false;
			}
		}else{
			isActive = false;
			
		}
		if(isActive){
			$(Selector.ACTIVITY_PANEL).find('.generate-que-btn').removeClass('disabled');
		}else{
			$(Selector.ACTIVITY_PANEL).find('.generate-que-btn').addClass('disabled');
		}
	}
	function updateTemplateLayout() {
		
	}
	$(document).bind(APP.eventObj.ON_SCREEN_RESIZE, function (e) {
		updateTemplateLayout();
	});

	
	function pageCompleted() {
		if (Selector.ON_COMPLETE) {
			Selector.ON_COMPLETE();
		}
		APP.courseDataObj.updatePageCompletion(2);
	}
}