function TypeQuestions() {
	var _this = this;
	var Selector = {};
	_this.start = function (_obj) {
		Selector = {
			ACTIVITY_PANEL: '.type-question-screen',
			SELECTED_CLASS: 'selected',
			ACTIVE_ITEM_CLASS: 'active',
			ITEM: '.input-box',						
			ON_CHANGE: null,
			ON_COMPLETE: null,
			defaultQues:1,
			maxLength:150,
			maxTotQues:10
		};
		Selector = $.extend(Selector, _obj);
		initTemplate();
	}
	_this.start();
	
	function initTemplate() {
		
		Selector.xmlNode = APP.globalXmlsObj.screenDataXML.typeQuestionScreen[0];		
		
		Selector.isCompleted = false;
		
		/* 1 */var str = '<div class="page type-question-screen " >';
		/* 2 */str += '<div class="page-panel no-padding-top clearfix">';
		
		 if(Selector.xmlNode.title){
			 var _style = Selector.xmlNode.title[0].style || "";
			 var _className = Selector.xmlNode.title[0].className || "";
			 str+= '<p class ="page-title '+_className+'" style="'+_style+'">'+Selector.xmlNode.title[0].Text+'</p>';
		 }
		 if(Selector.xmlNode.ostText){
			 var len = Selector.xmlNode.ostText[0].text.length;
			 /* 2a */str+='<div class="ost-panel">'
			 for(var i=0; i<len; i++){
				var _style = Selector.xmlNode.ostText[0].text[i].style || "";
				var _className = Selector.xmlNode.ostText[0].text[i].className || "";
				str+= '<p class ="txt '+_className+'" style="'+_style+'">'+Selector.xmlNode.ostText[0].text[i].Text+'</p>';
			 }
			  /* 2a */str+='</div>';
		 }
		 //-- type question
		 
		  /* 3 */str+='<div class="type-que-panel">'
			var globalObj =APP.interviewQuesObj.typedQues;
			var len = globalObj.length;
			if(len <= Selector.defaultQues){
				len = Selector.defaultQues;
			}
			/* 3a */str+='<div class="ques">';
				str+='<div class="no-que-txt">';
					str+='<p class="txt">'+Selector.xmlNode.placeholderQuestion[0].noQueText[0].Text+'</p>';
				str+='</div>';
			
			for(var i=0; i<len; i++){	
				//--only create first time
			  if(globalObj.length < Selector.defaultQues){
				  if(i==0){
					 globalObj = []; 
				  }
				  var temp = {
					  id:i,
					  txt:''					  
				  }
				  APP.interviewQuesObj.typedQues.push(temp);
				  
			  }
				str+= addQuestionPanel(i, true);				
			}
			/* 3a */str+='</div>';
			var returned = APP.GetHtmlStructObj.getCommonBtn({
					className:'add-question',
					btnObj:Selector.xmlNode.placeholderQuestion[0].addQuestionBtn 
				}); 
				if(returned !=''){
					str+=returned;
				}
			
		  /* 3 */str+='</div>';		 
		//-- next step
		 var returned = APP.GetHtmlStructObj.getCommonBtn({
				className:'margin-top pull-right btn-next-step',
				btnObj:APP.globalXmlsObj.screenDataXML.commonText[0].nextStepBtn 
			}); 
			if(returned !=''){
				str+=returned;
			}
			/* 2 */str+='</div>';
		/* 1 */str+='</div>';
		$('#page-container').html(str);
		$(document).trigger(APP.eventObj.ON_PAGE_LOADCOMPLETE);
		
		validateInput();
		updateTemplateLayout();
		addTemplateEvent();
		updateStatus();
		
	}
	function validateInput(){
		$(Selector.ACTIVITY_PANEL).find(Selector.ITEM).attr('maxlength',Selector.maxLength);
		Selector.totalItem = $(Selector.ACTIVITY_PANEL).find('.text-area').length;
		$(Selector.ACTIVITY_PANEL).find(Selector.ITEM).each(function (inx){
			var val= $.trim($(this).val());
			var len = $(this).val().length;			
			$(this).data('currlength', len);
			
			if(val == ''){
				$(this).siblings('.placeholder-txt').show();	
			}else{
				$(this).siblings('.placeholder-txt').hide();	
			}
			
			var $txtElm = $(this).siblings('.indicator-panel');
			pg_updateLeftChar($txtElm, len);
		})
		if((Selector.totalItem) >= Selector.maxTotQues){
			$(Selector.ACTIVITY_PANEL).find('.add-question').addClass('disabled');
		}else{
			$(Selector.ACTIVITY_PANEL).find('.add-question').removeClass('disabled');
		}
		if(Selector.totalItem<=0){
			$(Selector.ACTIVITY_PANEL).find('.no-que-txt').show();
		}else{
			$(Selector.ACTIVITY_PANEL).find('.no-que-txt').hide();
		}
	}
	function addTemplateEvent() {
		$('#app-body').on('click', '.type-question-screen .placeholder-txt', function (e) {
			$(this).hide();
			$(this).siblings('.input-box').focus();
		});
		$('#app-body').on('focus', '.type-question-screen .input-box', function (e) {
			
			$(this).siblings('.placeholder-txt').hide();	
			
		});
		
		$(Selector.ACTIVITY_PANEL).find('.add-question').on('click', function (e) {
			if ($(this).hasClass('disabled')) {return false;}
			Selector.totalItem = $(Selector.ACTIVITY_PANEL).find('.text-area').length;
			
			addQuestionPanel((Selector.totalItem), false);	
			
		});
		var evt="keydown keyup blur";
		if(APP.systemDetectorObj.browserName == 'ie'){
			evt= "keypress keyup blur"
		}
		
		$('#app-body').on('click', '.type-question-screen .delete-btn', function (event) {
			//console.log('delete...');
			var $curr =$(this).parents('.question');
			$curr.removeClass('animated fadeInDown').addClass('animated fadeOutUp');
			setTimeout(function(){
				$curr.remove();
				rearrangeData();
			}, 500);
			
		})
		$('#app-body').on(evt, '.type-question-screen .input-box', function (event) {
			//console.log('$(Selector.ACTIVITY_PANEL).find(Selector.ITEM): '+$(Selector.ACTIVITY_PANEL).find(Selector.ITEM).length)
			var val= $.trim($(this).val());
			//console.log(val);
			var id = $(this).data('id');			
			var len = $(this).val().length;			
			$(this).data('currlength', len);
			var $txtElm = $(this).siblings('.indicator-panel');
			if(val == ''){
				$(this).siblings('.placeholder-txt').show();	
			}else{
				$(this).siblings('.placeholder-txt').hide();	
			}
			pg_updateLeftChar($txtElm, len);
			if (Selector.ON_CHANGE) {
				Selector.ON_CHANGE(id);
			}
			checkInterviewQuesObj();
			updateStatus();
		});
		
	}
	function addQuestionPanel(_currIndx, _isFirstTime){
		//take numbers from xmls
		var str='';
		var num = APP.commonFunObj.getNumberTxt(_currIndx);
		var intxt = ''
		var animatedClass = '';
		if(_isFirstTime){
			if(APP.interviewQuesObj.typedQues.length){
				if(APP.interviewQuesObj.typedQues[_currIndx] != null){
					intxt = APP.interviewQuesObj.typedQues[_currIndx].txt || '';
				}
			}
		}else{
			animatedClass = 'animated fadeInDown'
			//add an entry in object
			APP.interviewQuesObj.typedQues[_currIndx]={
					id : _currIndx,
					txt:''
				}
			
		}
		str+='<div class="question '+animatedClass+'">';
			str+='<div class="head ">';
				str+='<div class="que-no ">';
					str+='<div class="txt"><strong><span class="qtitle">'+Selector.xmlNode.placeholderQuestion[0].qTitle[0].Text+'</span> <span class="num">'+num+'</span></strong></div>'; 
				str+='</div>'; 
				str+='<a class="btn delete-btn icon-only" href="javascript:void(0);" >'				
					str+='<span class="btn-icon font-icon">&#xe910;</span>';
				str+='</a>';
			str+='</div>'; 
			str+='<div class="input-panel">'; 
				str+='<textarea class="text-area input-box" data-id="'+_currIndx+'" data-currlength="0">'+intxt+'</textarea>'; 
				str+='<span class="placeholder-txt">'+Selector.xmlNode.placeholderQuestion[0].queText[0].Text+'</span>';				
				str+='<div class="indicator-panel"><i><span class="wd-left-length"></span> '+Selector.xmlNode.placeholderQuestion[0].charLeft[0].Text+'</i></div>';
			str+='</div>';
		str+='</div>';
		if(_isFirstTime){
			return str;			
		}else{
			$(Selector.ACTIVITY_PANEL).find('.ques').append(str);
			setTimeout(function(){
				var isView = APP.commonFunObj.isElementInView($('.add-question_div'), 'bottom');
				if(!isView){
					APP.commonFunObj.scrollToElement($('.add-question_div'), true, 'bottom')
				}
			},500);
			validateInput();
		}				
	}
	function pg_updateLeftChar(_el,_curr){
		var leftLength = Selector.maxLength - _curr;
		$(_el).find('.wd-left-length').html(leftLength);
	}
	
	function updateStatus() {		
		Selector.isCompleted = true;		
		if (Selector.isCompleted) {
			pageCompleted();
		}
		
	}
	function checkInterviewQuesObj(){
		
		var $obj = $(Selector.ACTIVITY_PANEL).find(Selector.ITEM);	
		//console.log('$obj: '+$obj.length)
		APP.interviewQuesObj.typedQues=[];
		$obj.each(function (idx) {
			//console.log('00idx: '+idx);
			var id = $(this).data('id');
			var txt= $.trim($(this).val());
			
			APP.interviewQuesObj.typedQues[idx]={id: id, txt:txt}
			
		})
		$(document).trigger(APP.eventObj.ON_PAGE_UPDATE);
	}
	function rearrangeData(){		
		var $obj = $(Selector.ACTIVITY_PANEL).find(Selector.ITEM);	
		//console.log('$obj: '+$obj.length)
		$obj.each(function (idx) {
			//console.log('idx: '+idx);
			$(this).data('id', idx);
			var num = APP.commonFunObj.getNumberTxt(idx);
			$(this).parents('.question').find('.que-no').find('.num').html(num);
		})
		
		validateInput();
		checkInterviewQuesObj();
	}
	
	function updateTemplateLayout() {
		
	}
	$(document).bind(APP.eventObj.ON_SCREEN_RESIZE, function (e) {
		updateTemplateLayout();
	});

	
	function pageCompleted() {
		if (Selector.ON_COMPLETE) {
			Selector.ON_COMPLETE();
		}
		APP.courseDataObj.updatePageCompletion(2);
	}
}