function CustomSkill() {
	var _this = this;
	var Selector = {};
	_this.start = function (_obj) {
		Selector = {
			ACTIVITY_PANEL: '.type-custom-skill',
			SELECTED_CLASS: 'selected',
			ACTIVE_ITEM_CLASS: 'active',
			ITEM: '.input-box',						
			ON_CHANGE: null,
			ON_COMPLETE: null,
			appendDiv:'#page-container',
			isSeparatePage:true,
			defaultCustomSkill:1,
			maxLength:80,
			maxTotCustomSkill:1
		};
		Selector = $.extend(Selector, _obj);
		initTemplate();
	}
	//_this.start();
	
	function initTemplate() {
		
		Selector.xmlNode = APP.globalXmlsObj.screenDataXML.skillSelectionScreen[0].customCompetency[0];		
		
		Selector.isCompleted = false;
		
		/* 1 */var str = '<div class="type-custom-skill " >';
		/* 2 */str += '<div class="no-padding-top clearfix">';
		
		 if(Selector.xmlNode.title){
			 var _style = Selector.xmlNode.title[0].style || "";
			 var _className = Selector.xmlNode.title[0].className || "";
			 str+= '<p class ="txt '+_className+'" style="'+_style+'">'+Selector.xmlNode.title[0].Text+'</p>';
		 }
		 str+='<div class="line-spacer black"><span/></div>';
		 if(Selector.xmlNode.ostText){
			 var len = Selector.xmlNode.ostText[0].text.length;
			 /* 2a */str+='<div class="ost-panel">'
			 for(var i=0; i<len; i++){
				var _style = Selector.xmlNode.ostText[0].text[i].style || "";
				var _className = Selector.xmlNode.ostText[0].text[i].className || "";
				str+= '<p class ="txt '+_className+'" style="'+_style+'">'+Selector.xmlNode.ostText[0].text[i].Text+'</p>';
			 }
			  /* 2a */str+='</div>';
		 }
		 //-- type custom skill
		 
		  /* 3 */str+='<div class="type-skill-panel">'
			var globalObj = APP.interviewQuesObj.typedSkill;
			var len = globalObj.length;
			if(len <= Selector.defaultCustomSkill){
				len = Selector.defaultCustomSkill;
			}
			/* 3a */str+='<div class="custm-skills">';
				str+='<div class="no-skill-txt">';
					str+='<p class="txt">'+Selector.xmlNode.noSkillText[0].Text+'</p>';
				str+='</div>';
			
			for(var i=0; i<len; i++){	
				//--only create first time
			  if(globalObj.length < Selector.defaultCustomSkill){
				  if(i==0){
					 globalObj = []; 
				  }
				  var temp = {
					  id:i,
					  title:'',
					  addedQ:[]
				  }
				  APP.interviewQuesObj.typedSkill.push(temp);
				  
			  }
				str+= addCustomSkillPanel(i, true);				
			}
			/* 3a */str+='</div>';
			if(Selector.maxTotCustomSkill > 1){
			var returned = APP.GetHtmlStructObj.getCommonBtn({
					className:'add-custom-skill',
					btnObj:Selector.xmlNode.addSkillBtn 
				}); 
				if(returned !=''){
					str+=returned;
				}
			}
		  /* 3 */str+='</div>';		 
		
		/* 2 */str+='</div>';
		/* 1 */str+='</div>';
		$(Selector.appendDiv).html(str);
		if(Selector.isSeparatePage){
			$(document).trigger(APP.eventObj.ON_PAGE_LOADCOMPLETE);
		}
		validateInput();
		updateTemplateLayout();
		addTemplateEvent();
		updateStatus();
		
	}
	function validateInput(){
		$(Selector.ACTIVITY_PANEL).find(Selector.ITEM).attr('maxlength',Selector.maxLength);
		Selector.totalItem = $(Selector.ACTIVITY_PANEL).find('.text-area').length;
		$(Selector.ACTIVITY_PANEL).find(Selector.ITEM).each(function (inx){
			var val= $.trim($(this).val());
			var len = $(this).val().length;			
			$(this).data('currlength', len);
			
			if(val == ''){
				$(this).siblings('.placeholder-txt').show();	
			}else{
				$(this).siblings('.placeholder-txt').hide();	
			}
			
			var $txtElm = $(this).siblings('.indicator-panel');
			pg_updateLeftChar($txtElm, len);
		})
		if((Selector.totalItem) >= Selector.maxTotCustomSkill){
			$(Selector.ACTIVITY_PANEL).find('.add-custom-skill').addClass('disabled');
		}else{
			$(Selector.ACTIVITY_PANEL).find('.add-custom-skill').removeClass('disabled');
		}
		if(Selector.totalItem<=0){
			$(Selector.ACTIVITY_PANEL).find('.no-skill-txt').show();
		}else{
			$(Selector.ACTIVITY_PANEL).find('.no-skill-txt').hide();
		}
	}
	function addTemplateEvent() {
		$('#app-body').on('click', '.type-custom-skill .placeholder-txt', function (e) {
			$(this).hide();
			$(this).siblings('.input-box').focus();
		});
		$('#app-body').on('focus', '.type-custom-skill .input-box', function (e) {			
			$(this).siblings('.placeholder-txt').hide();	
			
		});
		$(Selector.ACTIVITY_PANEL).find('.add-custom-skill').on('click', function (e) {
			if ($(this).hasClass('disabled')) {return false;}
			Selector.totalItem = $(Selector.ACTIVITY_PANEL).find('.text-area').length;
			
			addCustomSkillPanel((Selector.totalItem), false);	
			
		});
		var evt="keydown keyup blur";
		if(APP.systemDetectorObj.browserName == 'ie'){
			evt= "keypress keyup blur"
		}
		
		$('#app-body').on('click', '.type-custom-skill .delete-btn', function (event) {
			//console.log('delete...');
			var $curr =$(this).parents('.custom-skill');
			$curr.removeClass('animated fadeInDown').addClass('animated fadeOutUp');
			setTimeout(function(){
				$curr.remove();
				rearrangeData();
			}, 500);
			
		})
		$('#app-body').on(evt, '.type-custom-skill .input-box', function (event) {
			//console.log('$(Selector.ACTIVITY_PANEL).find(Selector.ITEM): '+$(Selector.ACTIVITY_PANEL).find(Selector.ITEM).length)
			var val= $.trim($(this).val());
			//console.log(val);
			var id = $(this).data('id');			
			var len = $(this).val().length;			
			$(this).data('currlength', len);
			var $txtElm = $(this).siblings('.indicator-panel');
			if(val == ''){
				$(this).siblings('.placeholder-txt').show();	
			}else{
				$(this).siblings('.placeholder-txt').hide();	
			}
			pg_updateLeftChar($txtElm, len);
			
			checkInterviewQuesObj();
			updateStatus();
			if (Selector.ON_CHANGE) {
				Selector.ON_CHANGE(id);
			}
		});
		
	}
	function addCustomSkillPanel(_currIndx, _isFirstTime){
		//take numbers from xmls
		var str='';
		var num = APP.commonFunObj.getNumberTxt(_currIndx);
		var intxt = ''
		var animatedClass = '';
		if(_isFirstTime){
			if(APP.interviewQuesObj.typedSkill.length){
				if(APP.interviewQuesObj.typedSkill[_currIndx] != null){
					intxt = APP.interviewQuesObj.typedSkill[_currIndx].title || '';
				}
			}
		}else{
			animatedClass = 'animated fadeInDown'
			//add an entry in object
			APP.interviewQuesObj.typedSkill[_currIndx]={
					id : _currIndx,
					title:'',
					addedQ:[]
				}
			
		}
		str+='<div class="custom-skill '+animatedClass+'">';
			str+='<div class="input-panel display-table">'; 
				str+='<div class="display-cell input-cell">';
					str+='<input class="text-area input-box" data-id="'+_currIndx+'" data-currlength="0" type="text" value="'+intxt+'" placeholder="'+Selector.xmlNode.inputText[0].Text+'"></input>'; 
					/* str+='<span class="placeholder-txt">'+Selector.xmlNode.inputText[0].Text+'</span>'; */				
					str+='<div class="indicator-panel"><i><span class="wd-left-length"></span> '+Selector.xmlNode.charLeft[0].Text+'</i></div>';
				str+='</div>';
				if(Selector.maxTotCustomSkill > 1){
				str+='<div class="display-cell btn-cell">';
					str+='<a class="btn delete-btn icon-only" href="javascript:void(0);" >'
						str+='<span class="btn-icon font-icon">&#xe910;</span>';
					str+='</a>';
				str+='</div>';
				}
			str+='</div>';
		str+='</div>';
		if(_isFirstTime){
			return str;			
		}else{
			$(Selector.ACTIVITY_PANEL).find('.custm-skills').append(str);
			
			validateInput();
		}				
	}
	function pg_updateLeftChar(_el,_curr){
		var leftLength = Selector.maxLength - _curr;
		$(_el).find('.wd-left-length').html(leftLength);
	}
	
	function updateStatus() {		
		Selector.isCompleted = true;		
		if (Selector.isCompleted) {
			pageCompleted();
		}		
	}
	function checkInterviewQuesObj(){		
		var $obj = $(Selector.ACTIVITY_PANEL).find(Selector.ITEM);	
		//console.log('$obj: '+$obj.length)
		//APP.interviewQuesObj.typedSkill=[];
		$obj.each(function (idx) {
			//console.log('00idx: '+idx);
			var id = $(this).data('id');
			var title= $.trim($(this).val());
			
			APP.interviewQuesObj.typedSkill[id].id=id
			APP.interviewQuesObj.typedSkill[id].title=title;
			
		})
		$(document).trigger(APP.eventObj.ON_PAGE_UPDATE);
	}
	function rearrangeData(){		
		var $obj = $(Selector.ACTIVITY_PANEL).find(Selector.ITEM);			
		$obj.each(function (idx) {			
			$(this).data('id', idx);			
		})		
		validateInput();
		checkInterviewQuesObj();
	}
	
	function updateTemplateLayout() {
		
	}
	$(document).bind(APP.eventObj.ON_SCREEN_RESIZE, function (e) {
		updateTemplateLayout();
	});

	
	function pageCompleted() {
		if (Selector.ON_COMPLETE) {
			Selector.ON_COMPLETE();
		}
		if(Selector.isSeparatePage){
			APP.courseDataObj.updatePageCompletion(2);
		}
	}
}