function GeneralQuestions() {
	var _this = this;
	var Selector = {};
	_this.start = function (_obj) {
		Selector = {
			ACTIVITY_PANEL: '.general-question-screen',
			SELECTED_CLASS: 'selected',
			ACTIVE_ITEM_CLASS: 'active',
			ITEM: '.choice-btn',						
			ON_CHANGE: null,
			ON_COMPLETE: null
		};
		Selector = $.extend(Selector, _obj);
		initTemplate();
	}
	_this.start();
	
	function initTemplate() {
		Selector.generalQuesXmlNode = APP.globalXmlsObj.globalXML.generalQuestions[0];	
		Selector.xmlNode = APP.globalXmlsObj.screenDataXML.generalQuestionScreen[0];	
		Selector.icon={
			normal:APP.globalXmlsObj.screenDataXML.commonText[0].questionsBtn[0].normalIcon[0].Text,
			selected:APP.globalXmlsObj.screenDataXML.commonText[0].questionsBtn[0].selectedIcon[0].Text
		}		
		Selector.isCompleted = false;
		
		/* 1 */var str = '<div class="page general-question-screen " >';
		/* 2 */str += '<div class="page-panel no-padding-top clearfix">';
		
		 if(Selector.xmlNode.title){
			 var _style = Selector.xmlNode.title[0].style || "";
			 var _className = Selector.xmlNode.title[0].className || "";
			 str+= '<p class ="page-title '+_className+'" style="'+_style+'">'+Selector.xmlNode.title[0].Text+'</p>';
		 }
		 if(Selector.xmlNode.ostText){
			 var len = Selector.xmlNode.ostText[0].text.length;
			 /* 2a */str+='<div class="ost-panel">'
			 for(var i=0; i<len; i++){
				var _style = Selector.xmlNode.ostText[0].text[i].style || "";
				var _className = Selector.xmlNode.ostText[0].text[i].className || "";
				str+= '<p class ="txt '+_className+'" style="'+_style+'">'+Selector.xmlNode.ostText[0].text[i].Text+'</p>';
			 }
			  /* 2a */str+='</div>';
		 }

		 //-- selectAllbutton
		 var returned = APP.GetHtmlStructObj.getCommonBtn({
				className:'select-all-btn',
				btnObj:APP.globalXmlsObj.screenDataXML.commonText[0].selectAllBtn 
			}); 
			if(returned !=''){
				str+=returned;
			}
		 
		 str+= APP.GetHtmlStructObj.selectedGeneralQuestions({			 
				mode:'selectable'
			}); 		  
		//-- next step
		 var returned = APP.GetHtmlStructObj.getCommonBtn({
				className:'margin-top pull-right btn-next-step',
				btnObj:APP.globalXmlsObj.screenDataXML.commonText[0].nextStepBtn 
			}); 
			if(returned !=''){
				str+=returned;
			}
			
			/* 2 */str+='</div>';
		/* 1 */str+='</div>';
		
		$('#page-container').html(str);
		$(document).trigger(APP.eventObj.ON_PAGE_LOADCOMPLETE);
		Selector.totalItem = $(Selector.ACTIVITY_PANEL).find(Selector.ITEM).length;
		setPreviousData();
		updateTemplateLayout();
		addTemplateEvent();
		updateStatus();
		
	}
	function setPreviousData(){
		var globalObj= APP.interviewQuesObj.generalQues;
		if(globalObj.length){	
			for(var i=0; i<globalObj.length; i++){
				var sel = '.choice-btn_'+globalObj[i].id;
				if(globalObj[i].pick == true){					
					$(Selector.ACTIVITY_PANEL).find(sel).addClass(Selector.SELECTED_CLASS);
					$(Selector.ACTIVITY_PANEL).find(sel).find('.btn-icon').html(Selector.icon.selected);
				}else{
					$(Selector.ACTIVITY_PANEL).find(sel).find('.btn-icon').html(Selector.icon.normal);
				}
			}
		}
	}
	function addTemplateEvent() {
		$(Selector.ACTIVITY_PANEL).find(Selector.ITEM).on('click', function () {
			if ($(this).hasClass('disabled')) {return false;}
			var id = $(this).data('id');			
			selectItem(id);
		});
		$(Selector.ACTIVITY_PANEL).find('.select-all-btn').on('click', function () {
			if ($(this).hasClass('disabled')) {return false;}
			selectDeselectAll();
		});
	}

	function selectItem(_id) {		
		var sel = '.choice-btn_'+_id;
		var $curr = $(Selector.ACTIVITY_PANEL).find(sel);
		if($curr.hasClass(Selector.SELECTED_CLASS)){
			$curr.removeClass(Selector.SELECTED_CLASS);
			$curr.find('.btn-icon').html(Selector.icon.normal);
		}else{
			$curr.addClass(Selector.SELECTED_CLASS);
			$curr.find('.btn-icon').html(Selector.icon.selected);
		}
		if (Selector.ON_CHANGE) {
			Selector.ON_CHANGE(_id);
		}
		checkInterviewQuesObj();
		updateStatus();
	}
	function selectDeselectAll(){
		var $obj = $(Selector.ACTIVITY_PANEL).find(Selector.ITEM);
		var $selected = $(Selector.ACTIVITY_PANEL).find(Selector.ITEM+'.'+Selector.SELECTED_CLASS);
		if($selected.length >= Selector.totalItem){
			//do deselect all
			$obj.each(function (idx) {
				$(this).removeClass(Selector.SELECTED_CLASS);
				$(this).find('.btn-icon').html(Selector.icon.normal);
				if (Selector.ON_CHANGE) {
					Selector.ON_CHANGE(idx);
				}
			});
		}else{
			//do select all
			$obj.each(function (idx) {
				$(this).addClass(Selector.SELECTED_CLASS);
				$(this).find('.btn-icon').html(Selector.icon.selected);
				if (Selector.ON_CHANGE) {
					Selector.ON_CHANGE(idx);
				}
			});
		}
		checkInterviewQuesObj();
		updateStatus();
	}
	function updateStatus() {
		Selector.isCompleted = true;
		var visitedCount = $(Selector.ACTIVITY_PANEL).find(Selector.ITEM+'.'+Selector.SELECTED_CLASS).length;
		if (visitedCount >= 1) {
			Selector.isCompleted = true;
		} else {
			Selector.isCompleted = false;
		}
		if (Selector.isCompleted) {
			pageCompleted();
		}
		
	}
	function checkInterviewQuesObj(){			
		var $selectedObj = $(Selector.ACTIVITY_PANEL).find(Selector.ITEM+'.'+Selector.SELECTED_CLASS);
		$selectedObj.each(function (idx) {
			//console.log('111idx: '+idx);
			var id = $(this).data('id');
			APP.interviewQuesObj.generalQues[id].pick=true;
		})

		var $normalObj = $(Selector.ACTIVITY_PANEL).find(Selector.ITEM+':not(.'+Selector.SELECTED_CLASS+')');
		$normalObj.each(function (idx) {
			//console.log('111idx: '+idx);
			var id = $(this).data('id');
			APP.interviewQuesObj.generalQues[id].pick=false;
		})
		$(document).trigger(APP.eventObj.ON_PAGE_UPDATE);
	}
	function updateTemplateLayout() {
		
	}
	$(document).bind(APP.eventObj.ON_SCREEN_RESIZE, function (e) {
		updateTemplateLayout();
	});

	
	function pageCompleted() {
		if (Selector.ON_COMPLETE) {
			Selector.ON_COMPLETE();
		}
		APP.courseDataObj.updatePageCompletion(2);
	}
}